<?php


require_once 'clubexpress_base.php';

class Clubexpress_class extends Clubexpress_base
{

    const URL_ADDITIONAL_MEMBER =  'content.aspx?page_id=147&club_id=886618&actr=3';
    const URL_CE_MEMBER_NUMBERS_GET = 'content.aspx?page_id=81&club_id=886618&actr=3';
    const URL_ADDITIONAL_INFORMATION_GET = 'content.aspx?page_id=151&club_id=886618&mm=s&member_id=~&quick_link=1&actr=3';
    const URL_BIO_INFORMATION_GET = 'content.aspx?page_id=79&club_id=886618&item_id=~&mm=s&member_id=~&actr=3';

    const SAVE_ADDITIONAL_MEMBER = REAL ? 0 : 1;
    const SAVE_ADDITIONAL_MEMBER_FILENAME = 'additional_member';
    const SAVE_ADDITIONAL_MEMBER_CSV = REAL ? 0 : 1;
    const SAVE_ADDITIONAL_MEMBER_CSV_FILENAME = 'additional_member_csv';
    const SAVE_CE_MEMBER_NUMBERS_GET = REAL ? 0 : 1;
    const SAVE_CE_MEMBER_NUMBERS_GET_FILENAME = 'member_numbers_get';
    const SAVE_CE_MEMBER_NUMBERS_FIRST = REAL ? 0 : 1;
    const SAVE_CE_MEMBER_NUMBERS_FIRST_FILENAME = 'member_numbers_first';
    const SAVE_ADDITIONAL_INFORMATION_GET = REAL ? 0 : 1;
    const SAVE_ADDITIONAL_INFORMATION_GET_FILENAME = 'additional_information';



    function __construct($user_name, $password, $name, $DIR, $human_name, $log, $debug)
    {
        parent::__construct($user_name, $password, $name, $DIR, $human_name, $log, $debug);
    }

    public function updateAdditionalInformation($ce_number, $changes/* $key, $old_value, $new_value*/)
    {
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];
        $headers[] = str_replace ('~', $ce_number, 'Referer: https://spa.clubexpress.com/content.aspx?page_id=80&club_id=886618&member_id=~&fs=');

        $url = str_replace ('~', $ce_number, self::URL_ADDITIONAL_INFORMATION_GET);
        $curl_result = self::getPage($url, self::SAVE_ADDITIONAL_INFORMATION_GET, self::SAVE_ADDITIONAL_INFORMATION_GET_FILENAME, $headers);

        self::parseForm($curl_result);
        self::parse_script_manager_TSM($curl_result);
        /*
	"changes_pending": "1",
	"ctl00$ctl00$q_19738a_1a": "2",
	"ctl00$ctl00$q_12582a_4a": "29",
	"ctl00$ctl00$q_23832a_5a": "56",
	"r_23833a_8a": "Yes",
	"r_23834a_11a": "Yes",
	"ctl00$ctl00$q_7074a_14a": "Mens+4.0",
	"ctl00$ctl00$q_15431a_15a": "4/21/2022",
	"r_9105a_18a": "I+Agree",
	"ctl00$ctl00$q_16383a_21a": "IPTPA",
	"ctl00$ctl00$q_16384a_22a": ""*/
        if (count($this->form_signup_to_event)) {
            $form_signup_to_event_old = $this->form_signup_to_event;
            $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
            $missing_keys = [];
            foreach($changes AS $key => $old_new) {
                $ce_key = $old_new['ce_key'];
                if(!isset($this->form_signup_to_event[$ce_key])) {
                    $missing_keys[] = $ce_key;
                }
                elseif (($this->form_signup_to_event[$ce_key] != $old_new['old']) && ($this->form_signup_to_event[$ce_key] != $old_new['default']) && !empty($this->form_signup_to_event[$ce_key])) {
                    //mismatch of old value
                    //note that the default setting is Unrated so an empty value gets returned as the default
                    //if (($key != 'ctl00$ctl00$q_7074a_14a') || ($this->form_signup_to_event[$key] != 'Unrated') || (!empty($old_value))) {
                        return -1;
                    /*} else {
                        //catch it
                        $i = 1;
                    }*/

                }
                $this->form_signup_to_event[$ce_key] = $old_new['new'];
                unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change

            }
            if(count($missing_keys) >= count($changes)) {
                //none of the changes are going to happen so return an error
                return -5;
            }
            //$this->form_signup_to_event['ctl00$ctl00$q_19738a_1a'] = ($this->form_signup_to_event['ctl00$ctl00$q_19738a_1a'] == 1) ? '2' : '1';
            unset($this->form_signup_to_event['DES_Group']);

            $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
            //$post_vars = 'style_sheet_manager_TSSM=&script_manager_TSM=%3B%3BSystem.Web.Extensions%2C+Version%3D4.0.0.0%2C+Culture%3Dneutral%2C+PublicKeyToken%3D31bf3856ad364e35%3Aen-US%3Aba1d5018-bf9d-4762-82f6-06087a49b5f6%3Aea597d4b%3Ab25378d2%3BTelerik.Web.UI%3Aen-US%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A16e4e7cd%3A365331c3%3A24ee1bba&__EVENTTARGET=ctl00%24ctl00%24hidden_export_button&__EVENTARGUMENT=&__VIEWSTATE=TpGTmmTbZmAI0MHDhRaUyz4Kg9gQvGHKvqQ7y9bQ9RSsd7SYHcG1MlYySng%2FtJujKob2%2FUkGMiRk4EPTOLfHU55Kpkc%3D&__VIEWSTATEGENERATOR=65E7F3AF&changes_pending=&ctl00%24ctl00%24hidden_membership_types=1%2C2%2C3%2C5%2C6%2C7%2C8%2C10&ctl00%24ctl00%24hidden_subgroup_id=-1';
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
                'Content-Type: application/x-www-form-urlencoded',
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $headers[] = str_replace ('~', $ce_number, 'Referer: https://spa.clubexpress.com/content.aspx?page_id=151&club_id=886618&mm=s&member_id=~&quick_link=1&actr=3');

            $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_additional_info', $post_vars, $headers);
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];
            $headers[] = str_replace ('~', $ce_number, 'Referer: https://spa.clubexpress.com/content.aspx?page_id=80&club_id=886618&member_id=~&fs=');

            $url = str_replace ('~', $ce_number, self::URL_ADDITIONAL_INFORMATION_GET);
            $curl_result = self::getPage($url, self::SAVE_ADDITIONAL_INFORMATION_GET, self::SAVE_ADDITIONAL_INFORMATION_GET_FILENAME, $headers);

            self::parseForm($curl_result);
            self::parse_script_manager_TSM($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $key => $old_new) {
                    $ce_key = $old_new['ce_key'];
                    if ($this->form_signup_to_event[$ce_key] != $old_new['new']) {
                        //mismatch of new value
                        return -2;
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                        if(!isset($changes[$key_old])) {
                            if($value_old != $this->form_signup_to_event[$key_old]) {
                                $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                            }
                        }
                    }
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        else {
            return -4;
        }
        return 0;
    }


    public function updateBioInformation($ce_number, $changes/* $key, $old_value, $new_value*/)
    {
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $headers[] = str_replace ('~', $ce_number, 'Referer: https://spa.clubexpress.com/content.aspx?page_id=13&club_id=886618&mm=s&member_id=~&actr=3');

        $url = str_replace ('~', $ce_number, self::URL_BIO_INFORMATION_GET);
        $curl_result = self::getPage($url, self::SAVE_ADDITIONAL_INFORMATION_GET, self::SAVE_ADDITIONAL_INFORMATION_GET_FILENAME, $headers);

        self::parseForm($curl_result);
        self::parse_script_manager_TSM($curl_result);

        if (count($this->form_signup_to_event)) {
            $form_signup_to_event_old = $this->form_signup_to_event;
            $files = [];
            $contentType = '286489677311088518682712627285';
            $this->form_signup_to_event['ctl00$ctl00$visibility_dropdown'] = '7';
            $this->form_signup_to_event['style_sheet_manager_TSSM'] = ";Telerik.Web.UI, Version=2018.2.710.45, Culture=neutral, PublicKeyToken=121fae78165ba3d4:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:1c2121e:e24b8e95";
            $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
            $this->form_signup_to_event['ctl00$ctl00$visibility_dropdown'] = '7';
            //$this->form_signup_to_event['ctl00_ctl00_uploadfile0'] = '';

            $post_vars = self::buildMultipartFormData($this->form_signup_to_event, $files, $contentType);

            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];
            $headers[] = "Content-Type: $contentType";
            $headers[] = str_replace ('~', $ce_number, 'Referer: https://spa.clubexpress.com/content.aspx?page_id=79&club_id=886618&item_id=~&mm=s&member_id=~&actr=3');

            $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_additional_info', $post_vars, $headers);
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $headers[] = str_replace ('~', $ce_number, 'Referer: https://spa.clubexpress.com/content.aspx?page_id=13&club_id=886618&mm=s&member_id=~&actr=3');

            $url = str_replace ('~', $ce_number, self::URL_BIO_INFORMATION_GET);
            $curl_result = self::getPage($url, self::SAVE_ADDITIONAL_INFORMATION_GET, self::SAVE_ADDITIONAL_INFORMATION_GET_FILENAME, $headers);

            self::parseForm($curl_result);
            if( $this->form_signup_to_event['ctl00$ctl00$visibility_dropdown'] != '7') {
                //mismatch of new value
                return -2;
            }

        }
        else {
            return -4;
        }
        return 0;
    }

    /**
     * Build multipart/form-data
     *
     * @param array @$data Data
     * @param array @$files 1-D array of files where key is field name and value if file contents
     * @param string &$contentType Retun variable for content type
     *
     * @return string Encoded data
     */
    private function buildMultipartFormData(array &$data, array &$files, &$contentType)
    {
        $eol = "\r\n";

        // Build test string
        $testStr = '';
        array_walk_recursive($data, function($item, $key) use (&$testStr, &$eol) {
            $testStr .= $key . $eol . $item . $eol;
        });

        // Get file content type and content.  Add to test string
        $finfo = finfo_open(FILEINFO_MIME_TYPE);
        $fileContent = array();
        $fileContentTypes = array();
        foreach ($files as $key=>$filename)
        {
            $fileContent[$key] = file_get_contents($filename);
            $fileContentTypes[$key] = finfo_file($finfo, $filename);
            $testStr .= $key . $eol . $fileContentTypes[$key] . $eol. $fileContent[$key] . $eol;
        }
        finfo_close($finfo);

        // Find a boundary not present in the test string
        $boundaryLen = 29;
        do {
            $boundary = '---------------------------';
            if(!empty($contentType)) {
                $boundary .= $contentType;
            }
            else {
                for ($i = 0; $i < $boundaryLen; $i++) {
                    $c = rand(0, 9);
                    $boundary .= $c;
                }
            }

            // Check test string
            if (strpos($testStr, $boundary) !== false)
            {
                $boundary = null;
            }
        } while ($boundary === null);
        unset($testStr);

        // Set content type
        $contentType = 'multipart/form-data; boundary='.$boundary;

        // Build data
        $rtn = '';
        $func = function($data, $baseKey = null) use (&$func, &$boundary, &$eol)
        {
            $rtn = '';
            foreach ($data as $key=>&$value)
            {
                // Get key
                $key = $baseKey === null ? $key : ($baseKey . '[' . $key . ']');

                // Add data
                if (is_array($value))
                    $rtn .= $func($value, $key);
                else
                    $rtn .= '--' . $boundary . $eol . 'Content-Disposition: form-data; name="'.$key.'"' . $eol . $eol . $value . $eol;
            }

            return $rtn;
        };
        $rtn = $func($data);

        // Add files
        foreach ($files as $key=>$filename)
        {
            $rtn .= '--' . $boundary . $eol . 'Content-Disposition: file; name="'.$key.'"; filename="'.basename($filename).'"' . $eol
                . 'Content-Type: ' . $fileContentTypes[$key] . $eol
                . 'Content-Transfer-Encoding: binary' . $eol . $eol
                . $fileContent[$key] . $eol;
        }

        return $rtn . '--' . $boundary . '--' . $eol;
    }



    /*public function  get_csv($filename)
    {
        global $DIR;

        $csv = [];
        $fileLocal = $DIR . 'data/' . $filename . '.csv';
        if(($handle = fopen($fileLocal, "r")) !== FALSE) {
            $first = true;
            while (($data_utf8 = fgetcsv($handle, 0, ",")) !== FALSE) {
                $data = array_map("utf8_encode", $data_utf8);
                if($first) {
                    $keys = $data;
                    $first = false;
                    continue;
                }
                if (count($data)) {
                    $csv_row = [];
                    foreach($keys AS $index => $key) {
                        $csv_row[$key] = $data[$index];
                    }
                    $csv[] = $csv_row;
                }
            }
            fclose($handle);
        }

        return $csv;
    }*/

    public function  create_csv($array, $filename)
    {
        global $DIR;

        $column_headings = array_keys($array[1]);

        $data_utf8 = array_map("utf8_decode", $column_headings);
        //$fileLocal = $DIR ."data/ce_number_to_member_number.csv";
        $fileLocal = $DIR . 'data/' . $filename . '.csv';
        if(($fh = fopen($fileLocal, "w")) !== FALSE) {

            $size = fputcsv($fh, $data_utf8);
            foreach ($array as $values) {
                $data_utf8 = array_map("utf8_decode", $values);
                $size = fputcsv($fh, $data_utf8);
            }
            fclose($fh);
        }
    }

    public function parse_script_manager_TSM($curl_result)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;

        //find the scripts
        $scripts = $dom->getElementsByTagName("script");
        if (($scripts->length == 0)) {
            return false;
        }
        $string = '_TSM_CombinedScripts_=';
        foreach ($scripts as $script) {
            $src = $script->getAttribute('src');
            $start = stripos($src, $string);
            if($start !== false) {
                $length_find = strlen($string);
                $end = strlen($src);
                $length = $end - $start - $length_find;
                $script_manager_TSM = substr($src, ($start + $length_find), $length);
                $this->form_signup_to_event['script_manager_TSM'] = urldecode($script_manager_TSM);
                break;
            }
        }
    }


    public function getAdditionalMemberData($filename, $update=false)
    {
        $values = $update ? [] : self::get_csv($filename);

        if(count($values)) {
            return $values;
        }

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Referer: https://spa.clubexpress.com/content.aspx?page_id=31&club_id=886618&action=login&sl='];


        $curl_result = self::getPage(self::URL_ADDITIONAL_MEMBER, self::SAVE_ADDITIONAL_MEMBER, self::SAVE_ADDITIONAL_MEMBER_FILENAME, $headers);

        self::parseForm($curl_result);

        if (count($this->form_signup_to_event)) {
            //$this->form_signup_to_event['style_sheet_manager_TSSM'] = ';Telerik.Web.UI, Version=2018.2.710.45, Culture=neutral, PublicKeyToken=121fae78165ba3d4:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:53e1db5a:d126a8ef';
            $this->form_signup_to_event['script_manager_TSM'] = ';;System.Web.Extensions, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35:en-US:bc17b1ef-7a1b-49cb-a795-5f1c64597a53:ea597d4b:b25378d2;Telerik.Web.UI:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:16e4e7cd:365331c3:24ee1bba:ed16cbdc:c128760b:874f8ea2:f46195d3:19620875:33715776:cda80b3:383e4ce8';
            $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$hidden_export_button';
            $this->form_signup_to_event['ctl00$ctl00$hidden_membership_types'] = "1,2,3,5,6,7,8,10";
            $this->form_signup_to_event['ctl00$ctl00$hidden_subgroup_id'] = "-1";
            unset($this->form_signup_to_event['ctl00$ctl00$hidden_export_button']);

            //"style_sheet_manager_TSSM": "",
            //"script_manager_TSM": ";;System.Web.Extensions,+Version=4.0.0.0,+Culture=neutral,+PublicKeyToken=31bf3856ad364e35:en-US:ba1d5018-bf9d-4762-82f6-06087a49b5f6:ea597d4b:b25378d2;Telerik.Web.UI:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:16e4e7cd:365331c3:24ee1bba",
            //"__EVENTTARGET": "ctl00$ctl00$hidden_export_button",
            //"__EVENTARGUMENT": "",
            //"__VIEWSTATE": "TpGTmmTbZmAI0MHDhRaUyz4Kg9gQvGHKvqQ7y9bQ9RSsd7SYHcG1MlYySng/tJujKob2/UkGMiRk4EPTOLfHU55Kpkc=",
            //"__VIEWSTATEGENERATOR": "65E7F3AF",
            //"changes_pending": "",
            //"ctl00$ctl00$hidden_membership_types": "1,2,3,5,6,7,8,10",
            //"ctl00$ctl00$hidden_subgroup_id": "-1"
            $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
            //$post_vars = 'style_sheet_manager_TSSM=&script_manager_TSM=%3B%3BSystem.Web.Extensions%2C+Version%3D4.0.0.0%2C+Culture%3Dneutral%2C+PublicKeyToken%3D31bf3856ad364e35%3Aen-US%3Aba1d5018-bf9d-4762-82f6-06087a49b5f6%3Aea597d4b%3Ab25378d2%3BTelerik.Web.UI%3Aen-US%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A16e4e7cd%3A365331c3%3A24ee1bba&__EVENTTARGET=ctl00%24ctl00%24hidden_export_button&__EVENTARGUMENT=&__VIEWSTATE=TpGTmmTbZmAI0MHDhRaUyz4Kg9gQvGHKvqQ7y9bQ9RSsd7SYHcG1MlYySng%2FtJujKob2%2FUkGMiRk4EPTOLfHU55Kpkc%3D&__VIEWSTATEGENERATOR=65E7F3AF&changes_pending=&ctl00%24ctl00%24hidden_membership_types=1%2C2%2C3%2C5%2C6%2C7%2C8%2C10&ctl00%24ctl00%24hidden_subgroup_id=-1';
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
                'Content-Type: application/x-www-form-urlencoded',
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1',
                'Referer: https://spa.clubexpress.com/content.aspx?page_id=147&club_id=886618&actr=3'];

            $curl_result_csv = self::post($this->url_signup_to_event,self::SAVE_ADDITIONAL_MEMBER_CSV, self::SAVE_ADDITIONAL_MEMBER_CSV_FILENAME, $post_vars, $headers);
            $rows = explode("\r\n", $curl_result_csv);
            $values = [];
            if(count($rows)) {
                $first = true;

                foreach($rows AS $row) {
                    $array = str_getcsv($row, ",", "\"");
                    if ($first) {
                        $row = str_replace('"', '', $row);
                        $keys = explode(',', $row);
                        $first = false;
                        continue;
                    }


                    $array_row = [];
                    foreach ($keys as $index => $key) {
                        if(!isset($array[$index])) {
                            $array_row[$key] = '';
                        }
                        else {
                            $array_row[$key] = $array[$index];
                        }
                    }
                    if(!empty($array_row['member_number'])) {
                        $values[] = $array_row;
                    }
                    else {
                        $i=1;
                    }
                    /*if(empty($array_row['first_name']) || empty($array_row['last_name'])) {
                        $i=1;
                    }
                    else {
                        $name = $array_row['first_name'] . ' ' . $array_row['last_name'];
                        if(!isset($values[$name])) {
                            $values[$name] = $array_row;
                        }
                        else {
                            $i=1;
                        }
                    }*/
                }
            }
        }
        self::create_csv($values, $filename);
        return $values;
    }

}