<?php
/*
 * Check for duplicate bookings for the same member on the same day and send them an email if any are found
https://sbpickleball.club/content.aspx?page_id=1301&club_id=886618&item_id=2482&cat=1035 Summer
https://sbpickleball.club/content.aspx?page_id=1301&club_id=886618&item_id=3434&cat=1196 Winter
 */
define('URL_BASE', 'sbpickleball.club');
define("SITE_SLUG", 'ce_dup');
define('CLUB_ID', 886618);
define('REAL', 1);                          //debug test #############################################
define('LOG', 1);                          //debug test #############################################
define('DEBUG', 1);                          //debug test #############################################
define('STORE_HTML', 0);
define('READ_HTML', 0);
define('SCHEDULE_DIRECTORY', 'schedules/');
define('NUMBER_TO_MEMBER_NUMBER_CSV', 'ce_number_to_member_spa');
define('BOOKING_DAYS_IN_ADVANCE', 8);       //start booking this many days in the future
define('CC_LIST', 'courtadministrator@sbpickleball.club');
define('BCC_LIST', 'billmacsween@gmail.com,njmag21@yahoo.com');
//define('CC_LIST', 'harrykeays78364@gmail.com');
//define('BCC_LIST', 'bobgauthier9034@gmail.com,metawareholdings@gmail.com');
define("DELAYS", 1);    //debug test #############################################
define("INFO", 1);
define("WARNING", 0);
define("CHANGE", 1);

if(isset($_SERVER['REMOTE_ADDR'])) {
    //being run from a browser which doesn't make sense so exit
    exit;
}
require_once "clubexpress_schedule_class.php";

echo date('Y-m-d H:i:s') . " Start of run\n";
$test = date_default_timezone_set('America/Phoenix');
echo date('Y-m-d H:i:s') . " After timezone change - result $test \n";
$DIR = __DIR__ . '/';       //get the root directory and pass it on to all the functions

$control_str['username'] = 'billmacsween';
$control_str['password'] = 'ce.BillM.1945';
$control_str['human_name'] = 'Bill MacSween';
$control_str['name'] = 'bill';


$logins = [
    'gplay' => ['username' => 'gplay', 'password' => 'Pickleball', 'human_name' => 'Group Play', 'name' => 'group'],
    'Drop-in' => ['username' => 'Drop-in', 'password' => 'Pickleball', 'human_name' => 'Drop- In', 'name' => 'drop'],
    'Rateddrop' => ['username' => 'Rateddrop', 'password' => 'Pickleball', 'human_name' => 'Rated Drop-In', 'name' => 'rated'],
    'slessons' => ['username' => 'slessons', 'password' => 'Pickleball', 'human_name' => 'SPA Lessons', 'name' => 'lesson'],
    'closed' => ['username' => 'closed', 'password' => 'Pickleball', 'human_name' => 'Court Closed', 'name' => 'closed'],
    'lplay' => ['username' => 'lplay', 'password' => 'Pickleball', 'human_name' => 'Level Play', 'name' => 'level'],
    'OrgPlay' => ['username' => 'OrgPlay', 'password' => 'PickleSPA22#', 'human_name' => 'Organized Play', 'name' => 'org'],
    'jtest' => ['username' => 'jtest', 'password' => 'PickleSPA23#', 'human_name' => 'Members Can', 'name' => 'hold'],
    'oplay' => ['username' => 'oplay', 'password' => 'PickleSPA24#', 'human_name' => 'Open Play', 'name' => 'openplay']
];

$logins_reverse = [];
foreach($logins AS $login_str => $login_values) {
    $login_values['logged_in'] = false;
    $login_values['class'] = null;
    $logins_reverse[$login_values['human_name']] = $login_values;
}


$class = initialize_users($control_str);        //initialize admin account

$now = time();
checkDuplicateBookings($now, $class);



function checkDuplicateBookings($now, $class) {
    global $logins, $logins_reverse;

    $time_this = $now;
    //$ignore = ['Group Play', 'Drop- In', 'Rated Drop-In'];
    $special = ['Ron Flanders', 'Mike Owens'];

    for($j=0; $j <= 7; $j++) {
        $date = date('Y-m-d', $time_this);
        $location_index = $class->getLocationIndex($date);
        $reservations = $class->getCalendar($date, $location_index);  //get the current clubexpress bookings for this day
        $bookings = [];
        foreach($reservations AS $time_str => $courts) {
            foreach($courts AS $court_id => $values) {
                if(isset($values['booking'])) {
                    $booking = $values['booking'];
                    $userName = $booking->userName;
                    if(isset($logins_reverse[$userName])) {
                        //skip common booking names like Group Play etc
                        continue;
                    }
                    if(in_array($userName, $special)) {
                        if(!empty($booking->usageDescription)) {
                            //some kind of special booking so allow it
                            continue;
                        }
                    }
                    $booking->time = $time_str;
                    $booking->court = $court_id;
                    $bookings[$userName][] = $booking;
                }
            }
        }

        foreach($bookings AS $userName => $values) {
            if(count($values) > 1) {
                require_once 'mail_local.php';

                if(empty($class->ce_numbers)) {
                    //try to find this user with the existing member file
                    $class->getCeMemberNumbers(NUMBER_TO_MEMBER_NUMBER_CSV, false);
                }
                if(!isset($class->ce_numbers[$userName])) {
                    //member not found to get a new member file
                    $class->getCeMemberNumbers(NUMBER_TO_MEMBER_NUMBER_CSV, true);
                }
                if(isset($class->ce_numbers[$userName])) {
                    $member = $class->ce_numbers[$userName];
                    $to = $member['email'];
                }
                else {
                    //couldn't find member
                }

                $subject = 'Multiple Courts Booked on ' . $date;
                $name = strtok($userName, " ");
                $message_email = "
                    <html>
                    <head>
                      <title>Duplicate Court Booking on $date</title>
                    </head>
                    <body>
                <p>Hi $name <br />You have booked multiple courts on the same day.  The club policy is that only one court may be booked by a member per day.  This allows other members a fair chance to also book courts.  You have booked the following courts on $date:
                <ul>";
                $courts = '';
                foreach($values AS $booking) {
                    $message_email .= '<li>Court ' . $booking->court . ' at ' . $booking->time . '</li>';
                    $courts .= 'Court ' . $booking->court . ' at ' . $booking->time . '; ';
                }
                $now = date('Y-m-d H:i:s');
                $message_email .= '</ul>';
                $message_email .= '<p>You may keep one of the courts but please cancel any additional courts. You will have 24 hours from the time of this email to choose which court you would like to keep; after that the system will automatically keep the earliest court and cancel any additional courts.'; // ('. $now . ')';
                $message_email .= '<br /><br />Thanks';
                $message_email .= '<br />Bill MacSween';
                $message_email .= '<br />Webmaster';
                $message_email .= "</p></body></html>";
                $headers_email = [];

                $i=1;
                if($i) {
                    $result = sendMail($to, $subject, $message_email, $headers_email, CC_LIST, BCC_LIST);
                    $failed = $result ? '' : '### FAILED ##';
                    echo "$date $failed $userName $to $courts \n";
                }

            }
        }


        $time_this += 86400;    //point to next date
    }
    $i=1;
}


function getBookingStats($now, $class) {

    $now = strtotime('2024-03-31 02:00:00');
    $end_date = date('Y-m-d', $now);
    $time_this = strtotime('2024-01-01');
    //$ignore = ['Group Play', 'Drop- In', 'Rated Drop-In'];
    $special = ['Ron Flanders', 'Mike Owens'];
    $stats = [];
    $day_count = [];
    while($time_this < $now) {
        $date = date('Y-m-d', $time_this);
        $get_date = getdate($time_this);
        $month = $get_date['mon'];
        $day_of_week = substr($get_date['weekday'], 0, 3);
        if(!isset($day_count[$month])) {
            $day_count[$month] = ['Sun' => 0, 'Mon' => 0, 'Tue' => 0, 'Wed' => 0, 'Thu' => 0, 'Fri' => 0, 'Sat' => 0];
        }
        $day_count[$month][$day_of_week]++;
        $reservations = $class->getCalendar($date, /*$day_location[$date]*/ 3434);  //get the current clubexpress bookings for this day
        foreach($reservations AS $time_str => $courts) {
            foreach($courts AS $court_id => $values) {
                if(isset($values['booking'])) {
                    /*$booking = $values['booking'];
                    if(stripos($booking->usageDescription, 'APPL') !== false) {
                        //count courts that were booked for the APPL
                        updateStats($stats, $month, $day_of_week, $time_str);
                    }
                    if(in_array($booking->userName, $special)) {
                        if(!empty($booking->usageDescription)) {
                            //some kind of special booking so allow it
                            //treat as open court
                            updateStats($stats, $month, $day_of_week, $time_str);
                        }
                    }*/
                }
                else {
                    //open court
                    updateStats($stats, $month, $day_of_week, $time_str);
                }
            }
        }

        $time_this += 86400;    //point to next date
    }
    $i=1;
    //flaten out array
    $flat = [];
    $month_names = ['Jan', 'Feb', 'Mar', 'Apr'];
    $days_name = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
    $times = ['11:00am','12:30pm', '2:00pm', '3:30pm', '5:00pm'];
    foreach($stats AS $month => $days) {
        foreach($times AS $time) {
            $day_array = ['Month' => $month_names[$month - 1], 'Time' => $time];
            foreach($days_name AS $day) {
                $day_array[$day] = $days[$day][$time];
            }
            $flat[] = $day_array;
        }
        $day_array = ['Month' => 'Number of days in month', 'Time' => ''];
        foreach($days_name AS $day) {
            $day_array[$day] = $day_count[$month][$day];
        }
        $flat[] = $day_array;
    }
    $filename = 'ce_stats';
    $class->create_csv($flat, $filename);
}

function updateStats(&$stats, $month, $day_of_week, $time_str)
{
    $days = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
    $times = ['11:00am', '12:30pm', '2:00pm', '3:30pm', '5:00pm'];

    if(!isset($stats[$month])) {
        foreach($days AS $day){
            foreach($times AS $time) {
                $stats[$month][$day][$time] = 0;
            }
        }
    }
    if(isset($stats[$month][$day_of_week][$time_str])) {
        $stats[$month][$day_of_week][$time_str]++;
    }
}

function check_bad_start_times(&$class, $now)
{
    $target_day = date('Y-m-d', $now);
    [$open_reservations, $current, $off_times] = $class->getCalendar($target_day);
    if(count($off_times)) {
        //delete the reservations
        foreach ($off_times as $court => $off_time) {
            foreach ($off_time as $firt_ts => $values) {
                //$class->cancelReservation($values->id);
            }
        }
        //make new reservations
        foreach ($off_times as $court => $off_time) {
            foreach ($off_time as $firt_ts => $values) {
                //$class->cancelReservation($values->id);
            }
        }
    }
}

function initialize_users($values) {
    global $DIR;


    $log = LOG;
    $debug = DEBUG;
    $store_html = STORE_HTML;
    $read_html = READ_HTML;
    $class = array();
    $class = new Clubexpress_class($values['username'], $values['password'], $values['name'], $DIR, $values['human_name'], $log, $debug, $read_html, $store_html);

    return $class;
}









