<?php

define('URL_BASE', 'sbpickleball.club');
define("SITE_SLUG", 'ce_event');
define('CLUB_ID', 886618);
define('EVENT_DAYS', 60);
define('REAL', 1);                          //debug test #############################################
define('LOG', 1);                          //debug test #############################################
define('DEBUG', 1);                          //debug test #############################################
define('STORE_HTML', 1);
define('READ_HTML', 0);
define('EVENTS_CSV', 'ce_events_category');
define('REMOVE_LIMIT_DAYS_IN_ADVANCE', 2);       //2 days in advance change the event category
define('DEFAULT_RELEASE_TIME', '13:00:00');
define('DEFAULT_EVENT_CLOSE_TIME', '18:00:00');
define('HOLD_MESSAGE', 'Reserve at 1PM Today');
define('SEARCH_CATEGORY', 'Weekly Round Robins');
define('REPLACE_CATEGORY', 'Weekly RR No Limit');
define('SCHEDULE_DIRECTORY', 'schedules/');
define('NUMBER_TO_MEMBER_NUMBER_CSV', 'ce_number_to_member_spa');
define('REFRESH_EVENTS', 1);    //1 - load new events, 0 - use file is it exists //debug test #############################################
define("DELAYS", 1);    //debug test #############################################
define("DO_IT", 1);     //debug test #############################################
/*$comm = [];
$comm['tes1']++;
$comm['test2'] = 5;
$comm['test2'] ??= 0;
$comm['test3'] ??= 2;*/



require_once 'clubexpress_event_category_class.php';

echo date('Y-m-d H:i:s') . " Start of run\n";
$test = date_default_timezone_set('America/Phoenix');
echo date('Y-m-d H:i:s') . " After timezone change - result $test \n";
$DIR = __DIR__ . '/';       //get the root directory and pass it on to all the functions

$control_str['username'] = 'billmacsween';
$control_str['password'] = 'ce.BillM.1945';
$control_str['human_name'] = 'Bill MacSween';
$control_str['name'] = 'bill';

$logins = [
    'gplay' => ['username' => 'gplay', 'password' => 'Pickleball', 'human_name' => 'Group Play', 'name' => 'group'],
    'Drop-in' => ['username' => 'Drop-in', 'password' => 'Pickleball', 'human_name' => 'Drop- In', 'name' => 'drop'],
    'Rateddrop' => ['username' => 'Rateddrop', 'password' => 'Pickleball', 'human_name' => 'Rated Drop-In', 'name' => 'rated'],
    'slessons' => ['username' => 'slessons', 'password' => 'Pickleball', 'human_name' => 'SPA Lessons', 'name' => 'lesson'],
    'closed' => ['username' => 'closed', 'password' => 'Pickleball', 'human_name' => 'Court Closed', 'name' => 'closed'],
    'lplay' => ['username' => 'lplay', 'password' => 'Pickleball', 'human_name' => 'Level Play', 'name' => 'level'],
    'OrgPlay' => ['username' => 'OrgPlay', 'password' => 'PickleSPA22#', 'human_name' => 'Organized Play', 'name' => 'org'],
    'jtest' => ['username' => 'jtest', 'password' => 'PickleSPA23#', 'human_name' => 'Members Can', 'name' => 'hold'],
    'oplay' => ['username' => 'oplay', 'password' => 'PickleSPA24#', 'human_name' => 'Open Play', 'name' => 'openplay']
];

$logins_reverse = [];
foreach($logins AS $login_str => $login_values) {
    $login_values['logged_in'] = false;
    $login_values['class'] = null;
    $logins_reverse[$login_values['human_name']] = $login_values;
}
$release_login = [2482 =>['7:00am' => ['login' => 'Drop-in', 'ce_str' => 'Drop- In OPEN'],
                '8:30am' => ['login' => 'Drop-in', 'ce_str' => 'Drop- In OPEN'],
                '10:00am' => ['login' => '', 'ce_str' => ''],
                '11:30am' => ['login' => '', 'ce_str' => ''],
                '1:00pm' => ['login' => '', 'ce_str' => ''],
                '2:30pm' => ['login' => '', 'ce_str' => ''],
                '4:00pm' => ['login' => '', 'ce_str' => ''],
                '5:30pm' => ['login' => '', 'ce_str' => '']],
                3434 => ['8:00am' => ['login' => 'Drop-in', 'ce_str' => 'Drop- In OPEN'],
                    '9:30am' => ['login' => 'Drop-in', 'ce_str' => 'Drop- In OPEN'],
                    '11:00am' => ['login' => '', 'ce_str' => ''],
                    '12:30pm' => ['login' => '', 'ce_str' => ''],
                    '2:00pm' => ['login' => '', 'ce_str' => ''],
                    '3:30pm' => ['login' => '', 'ce_str' => ''],
                    '5:00pm' => ['login' => '', 'ce_str' => '']]];
$days = ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'];

$class = initialize_users($control_str);        //initialize admin account

do_change_category($control_str);

function do_change_category($control_str)
{
    global $DIR, $class, $logins;

    $fake_time = false;
    $now = time();
    //$now = strtotime('2024-07-07 19:00:01');  //debug test #############################################
    //$fake_time = true;                        //debug test #############################################

    $timer = time();

    $today = date('Y-m-d', $now);
    $tomorrow = date('Y-m-d', ($now + 86400));

    $class->log_message(("Start of daily run"), true, false);

    //get the Excel to clubexpress translation file
    [$excel_to_ce, $ce_to_excel] = get_translations();

    $logged_in = $class->login(true);         //login as admin
    if (!$logged_in) {
        //login failed so no use continuing
        $class->log_message("Login Failed: {$control_str['username']} / {$control_str['password']}", true);
        $class->log_result();
        return;
    }

    $events = $class->getEvents(($now + 86400), EVENT_DAYS, EVENTS_CSV, REFRESH_EVENTS, true);     //get new event list starting with tomorrow's events and save it for debugging purposes
    $class->log_message("Check for errors in future events", true);

    //$check_events = get_check_events($events);
    //wait until 1PM
    $now_current = $fake_time ? (strtotime($today . ' ' . DEFAULT_RELEASE_TIME) -2) : time();
    if($error = wait($now_current, $today,DEFAULT_RELEASE_TIME, 0, ("changing event category at 1PM for $today"))) {
        return $error;
    }
    //$class->log_message("Change categories for tomorrow's events", true);

    //change the category from 'Weekly Round Robins' to 'Weekly RR No Limit' for events 2 days from now so that people who have reached their
    //  booking limit can sign up if slots are still available
    //change_category($events, $now_current);       //leave out this function as of Jan 1, 2024
    $class->log_message("Early release of courts for tomorrow's events", true);
    //release some courts for tomorrow's events if registration is low
    advance_event_release($events, $tomorrow, $excel_to_ce);


    //wait until event registration closing time (6:00pm) and login
    $now_current = $fake_time ? (strtotime($today . ' ' . DEFAULT_EVENT_CLOSE_TIME) -2) : time();
    if($error = wait($now_current, $today,DEFAULT_EVENT_CLOSE_TIME, 0, ("releasing courts at 6PM for  $today"))) {
        return $error;
    }
    $events = $class->getEvents(($now + 86400), EVENT_DAYS, EVENTS_CSV, REFRESH_EVENTS, true);      //get new event list starting with tomorrow's events and save it for debugging purposes
    $now_current = $fake_time ? (strtotime($today . ' ' . DEFAULT_EVENT_CLOSE_TIME) +2) : time();
    $class->log_message("Final release of courts for tomorrow's events", true);
    //it's now 6PM so release any unneeded courts for tomorrow's events
    //reset all of the login classes since any logins from earlier in the day have expired
    foreach($logins AS $key => $temp) {
        unset($logins[$key]['logged_in'], $logins[$key]['class'], $logins[$key]['date']);
    }
    close_event_release($events, $now_current, $excel_to_ce);

    $class->log_message(("End of Run"), true, false);
    $class->log_result();       //file the results of the day's run
}

function get_check_events($events)
{
    global $class, $DIR;

    //get first event to get the end date
    foreach ($events as $event) {
        break;
    }
    $end_date = $event['date'] . ' 12:00:00';
    $start_date = date('Y-m-d 12:00:00');
    $end_date_unix = strtotime($end_date);
    $start_date_unix = strtotime($start_date);

    $check_events = [];
    //get the contents of the SPA Special files

    $dir = $DIR . 'data/schedules';
    $files = scandir($dir);
    $days = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
    foreach ($files as $filename) {
        if (($start = stripos($filename, 'spa_event_check_')) !== false) {
            //looks like a event check file
            if (stripos($filename, '.csv') !== false) {
                //it's a csv - example SPA Schedule 2023-03-01.csv
                $schedule_date_location = trim(str_replace(['spa_event_check_', '.csv'], '', $filename));   //extract the file date from the name by removing SPA Schedule and .csv
                $schedule_strings = explode('_', $schedule_date_location);       //separate the date from the location index
                $schedule_date = $schedule_strings[0];
                $schedule_date_unix = strtotime($schedule_date . ' 12:00:00');  //get the unix value for the date built into the filename
                //$location_index = $schedule_strings[1];
                if (empty($schedule_date_unix)) {
                    $class->log_message("Failed to get date from filename $filename", true, false);
                    //no sure if there is a messed up schedule file to better to not run any further
                    $class->log_result();
                    return;
                }
            }
            $filename_this = SCHEDULE_DIRECTORY . $filename;    //build filename
            $filename_this = str_replace('.csv', '', $filename_this);   //remove .csv
            $event_checks = $class->get_csv($filename_this);
            $check_events_this = [];
            foreach ($event_checks as $event_check) {
                $check_events_this[$event_check['Day']] ??= [];
                if (isset($check_events_this[trim($event_check['Day'])][trim($event_check['Name'])])) {
                    //duplicate so stop
                }
                $check_events_this[trim($event_check['Day'])][trim($event_check['Name'])] = $event_check;
            }
            //populate the $check_events array
            $next_date = $schedule_date_unix;
            while ($next_date <= $end_date_unix) {
                $getdate = getdate($next_date);
                $day_of_week = $days[$getdate['wday']];
                $date = date('Y-m-d', $next_date);
                $check_events[$date] = isset($check_events_this[$day_of_week]) ? $check_events_this[$day_of_week] : [];
                $next_date += 86400;
            }
        }
    }
    return $check_events;
}

/*function change_category($events, $now)
{
    global $class, $days;

    $today_unix = strtotime(date('Y-m-d 00:00:00', $now));
    $categories = [SEARCH_CATEGORY => "38555", REPLACE_CATEGORY => "38556"];
    foreach($events AS $event) {
        $changes = [];
        $msg = [];

        if(($event['category'] == SEARCH_CATEGORY) || ($event['category'] == REPLACE_CATEGORY)) {
            $cancelled = (stripos($event['title'], 'CANCELED') !== false);
            if($cancelled) {
                $i=1;
            }
            $title = str_replace(' -- CANCELED', '' , $event['title']);
            $date_event = $event['date'];
            $date_event_unix = strtotime($date_event);
            $start_time = strtolower(substr($event['Start'], 10, 10));
            $start_time = str_replace(' ', '', $start_time);
            $get_date = getdate($date_event_unix);
            $day_of_week = $days[$get_date['wday']];    //
            if($date_event == '2023-10-09') {
                $i=1;
            }

            if(($date_event_unix - $today_unix) <= (REMOVE_LIMIT_DAYS_IN_ADVANCE * 86400)) {
                if($event['category'] == 'Weekly Round Robins') {
                    $changes['ctl00$ctl00$category_dropdown'] = ['old' => $categories['Weekly Round Robins'], 'new' => $categories['Weekly RR No Limit'], 'default' => $categories['Weekly RR No Limit']];
                    $msg[] = 'Change category to Weekly RR No Limit';
                }
            }
        }
        if(count($changes)) {
            if(DO_IT) {
                $result = $class->updateEventCategory($event, $changes, true);
            }
            else {
                $result = 0;
            }

            if(!empty($result)) {
                //error of some sort so exit
                $error_message = '***ERROR**** ' . $event['date'] . ' ' . $start_time . ' ' . $day_of_week . ' ' . $event['title'] . ' : ' . implode(' ; ', $msg);
                $class->log_message($error_message, true);
                $class->log_result();       //file the results of the day's run
                break;
            }
            else {
                $error_message = $event['date'] . ' ' . $start_time . ' ' . $day_of_week . ' ' . $event['title'] . ' : ' . implode(' ; ', $msg);
                $class->log_message($error_message, true);
            }
        }
    }
}*/

function advance_event_release($events, $target_date, $excel_to_ce)
{
    global $class, $release_login, $days;

    foreach($events AS $event) {
        $changes = [];
        $msg = [];

        if (($event['category'] == SEARCH_CATEGORY) || ($event['category'] == REPLACE_CATEGORY)) {
            $cancelled = (stripos($event['title'], 'CANCELED') !== false);
            if ($cancelled) {
                $i = 1;
            }
            $title = str_replace(' -- CANCELED', '', $event['title']);
            $date_event = $event['date'];
            $date_event_unix = strtotime($date_event);
            $start_time = strtolower(substr($event['Start'], 10, 10));
            $start_time = str_replace(' ', '', $start_time);
            $get_date = getdate($date_event_unix);
            $day_of_week = $days[$get_date['wday']];    //
            if ($date_event == '2023-10-17') {
                $i = 1;
            }

            $date_reg_closes_date_time_unix = strtotime($event['date_reg_closes_date_time']);
            if (($target_date == $date_event) || $cancelled) {
                preg_match_all('!\d+!', $event['Location'], $courts_event);
                $registered = ($event['registered'] == 'N') ? 0 : $event['registered'];
                $courts_needed = intval($registered / 4) + 1;;
                $courts_count_remove = count($courts_event[0]) - $courts_needed;
                $class->log_message(($date_event . ' Active: ' . $event['date_reg_opens_date_time'] . ' ' . $event['title']
                    . ' Registered ' . intval($event['registered']) . '/' . intval($event['capacity'])
                    . ' Waiting ' . intval($event['waiting']) . '/' . intval($event['max_waitlist'])
                    . ' Courts to release: ' . $courts_count_remove), true, true);
                if ($courts_count_remove > 0) {
                    $get_date = getdate($date_event_unix);
                    $day_of_week = $days[$get_date['wday']];    //get day of week
                    $courts_to_release = array_reverse($courts_event[0]);
                    $location_index = $class->getLocationIndex($date_event);
                    $reservations_ce = $class->getCalendar($date_event, $location_index);
                    $ce_entry = $excel_to_ce[$title]['ClubExpress String'];
                    $ce_description = str_replace('Organized Play ', '', $ce_entry);
                    for ($i = 0; $i < $courts_count_remove; $i++) {
                        $court_id = $courts_to_release[$i];
                        $booking = $reservations_ce[$start_time][$court_id]['booking'] ?? NULL;
                        $release_type = $release_login[$location_index][$start_time];
                        if (!is_null($booking) && ($booking->userName == 'Organized Play') && ($booking->usageDescription == $ce_description)) {
                            $class->log_message(("Release court for {$event['title']} to " . (empty($release_type['login']) ? 'Member Reserve - NOT RELEASED' : $release_type['ce_str']) . "  ($day_of_week $date_event $start_time Court: $court_id)"), true, false);
                            if(DO_IT) {
                                if(!empty($release_type['login'])) {        //temporary change to not release courts to Member Reserve
                                    [$success_cancel, $success_book] = update_ce($reservations_ce[$start_time][$court_id], $release_type['login'], $release_type['ce_str'], $date_event, $start_time, $court_id, $location_index);
                                }

                            }
                            else {
                                $success_cancel = true;
                                $success_book = true;
                            }
                        } else {
                            $booking_str = is_null($booking) ? 'booking is null' : 'booking is not null';
                            $class->log_message(("No update because: $booking_str user_name is {$booking->userName} usage is {$booking->usageDescription} ce_usage is $ce_description location_index is $location_index"), true, false);
                        }
                    }
                }
            }

        }
    }
}

function close_event_release($events, $now, $excel_to_ce)
{
    global $class, $release_login, $days;

    foreach($events AS $event) {
        $changes = [];
        $msg = [];

        if (($event['category'] == SEARCH_CATEGORY) || ($event['category'] == REPLACE_CATEGORY)) {
            $cancelled = (stripos($event['title'], 'CANCELED') !== false);
            if ($cancelled) {
                $i = 1;
            }
            $title = str_replace(' -- CANCELED', '', $event['title']);
            $date_event = $event['date'];
            $date_event_unix = strtotime($date_event);
            $start_time = strtolower(substr($event['Start'], 10, 10));
            $start_time = str_replace(' ', '', $start_time);
            $get_date = getdate($date_event_unix);
            $day_of_week = $days[$get_date['wday']];    //
            if ($date_event == '2025-01-29') {
                $i = 1;
            }

            $date_reg_closes_date_time_unix = strtotime($event['date_reg_closes_date_time']);
            if (($now >= $date_reg_closes_date_time_unix) || $cancelled) {
                preg_match_all('!\d+!', $event['Location'], $courts_event);
                $registered = ($event['registered'] == 'N') ? 0 : $event['registered'];
                $courts_needed = intval($registered / 4);
                $spares = $registered % 4;
                //as of Jan 1, 2024 don't round up for spares
                //$courts_needed += ($spares >= 2) ? 1 : 0;
                $courts_count_remove = count($courts_event[0]) - $courts_needed;
                $class->log_message(($date_event . ' Active: ' . $event['date_reg_opens_date_time'] . ' ' . $event['title']
                    . ' Registered ' . intval($event['registered']) . '/' . intval($event['capacity'])
                    . ' Waiting ' . intval($event['waiting']) . '/' . intval($event['max_waitlist'])
                    . ' Courts to release: ' . $courts_count_remove), true, true);
                if ($courts_count_remove > 0) {
                    $get_date = getdate($date_event_unix);
                    $day_of_week = $days[$get_date['wday']];    //get day of week
                    $courts_to_release = array_reverse($courts_event[0]);
                    $location_index = $class->getLocationIndex($date_event);
                    $reservations_ce = $class->getCalendar($date_event, $location_index);
                    $ce_entry = $excel_to_ce[$title]['ClubExpress String'];
                    $ce_description = str_replace('Organized Play ', '', $ce_entry);
                    for ($i = 0; $i < $courts_count_remove; $i++) {
                        $court_id = $courts_to_release[$i];
                        $booking = $reservations_ce[$start_time][$court_id]['booking'] ?? NULL;
                        $release_type = $release_login[$location_index][$start_time];
                        if (!is_null($booking) && ($booking->userName == 'Organized Play') && ($booking->usageDescription == $ce_description)) {
                            $class->log_message(("Release court for {$event['title']} to " . (empty($release_type['login']) ? 'Member Reserve - NOT RELEASED' : $release_type['ce_str']) . "  ($day_of_week $date_event $start_time Court: $court_id)"), true, false);
                            if(DO_IT) {
                                if(!empty($release_type['login'])) {        //temporary change to not release courts to Member Reserve
                                    [$success_cancel, $success_book] = update_ce($reservations_ce[$start_time][$court_id], $release_type['login'], $release_type['ce_str'], $date_event, $start_time, $court_id, $location_index);
                                }
                            }
                            else {
                                $success_cancel = true;
                                $success_book = true;
                            }
                        } else {
                            $booking_str = is_null($booking) ? 'booking is null' : 'booking is not null';
                            $class->log_message(("No update because: $booking_str user_name is {$booking->userName} usage is {$booking->usageDescription} ce_usage is $ce_description location_index is $location_index"), true, false);
                        }
                    }
                }
            }

        }
    }
}

function wait($now, $today,  $time_of_day, $delta, $message)
{
    global $class;

    $action_time = $today . ' ' . $time_of_day;
    $action_time_unix = strtotime($action_time);

    if (($now + $delta) < $action_time_unix) {
        //wake up again at the action time adjusted by delta
        $delay = $action_time_unix - $now - $delta + 1;
        $class->log_message("Delaying $delay seconds until $action_time $message ", true);
        if (DELAYS && ($delay > 0)) {
            sleep($delay);
        }
    }
    $logged_in = $class->login(true);         //login as admin
    if (!$logged_in) {
        //login failed so no use continuing
        $class->log_message("Login Failed: {$control_str['username']} / {$control_str['password']} at $message", true);
        $class->log_result();
        return -1;
    }
    return 0;
}

function get_translations()
{
    global $class;
    //get the Excel to clubexpress translation file
    $trans_filename = SCHEDULE_DIRECTORY . 'schedule_translation';
    $translations = $class->get_csv($trans_filename);
    if (count($translations) == 0) {
        //missing the translation file so bail out
        $class->log_message(("###Missing Translation File###"), true, false);
    }
    $excel_to_ce = [];
    $ce_to_excel = [];
    $missing_login_count = 0;
    //build the mapping arrays that map excel to clubexpress and vise versa
    foreach ($translations as $values) {
        if (empty($values['Excel String'])) {
            //blank line
            continue;
        }
        $excel_to_ce[$values['Excel String']] = $values;
        $ce_to_excel[$values['ClubExpress String']] = $values;
    }
    ksort($excel_to_ce);
    ksort($ce_to_excel);
    return [$excel_to_ce, $ce_to_excel];
}


function initialize_users($values) {
    global $DIR;


    $log = LOG;
    $debug = DEBUG;
    $store_html = STORE_HTML;
    $read_html = READ_HTML;
    $class = array();
    $class = new Clubexpress_class($values['username'], $values['password'], $values['name'], $DIR, $values['human_name'], $log, $debug, $read_html, $store_html);

    return $class;
}

function update_ce($court_values, $login_booking, $ce_string, $date, $time_str, $court_id, $location_id)
{
    global $logins, $logins_reverse, $class;

    $success_cancel = true;     //assume cancel is fine
    $success_book = null;
    if(isset($court_values['booking'])) {
        //we have to cancel an existing booking
        $success_cancel = false;    //cancel is necessary
        $login_cancel = $court_values['booking']->userName;     //get the username of the booking to cancel
        if(isset($logins_reverse[$login_cancel])) {
            $login_cancel = $logins_reverse[$login_cancel]['username']; //get login reverse data
            if(empty($logins[$login_cancel]['class'])) {
                //not logged into this account yet
                $logins[$login_cancel]['class'] = initialize_users($logins[$login_cancel]);
                $logins[$login_cancel]['logged_in'] = $logins[$login_cancel]['class']->login(true);         //login as coordinator
                if (!$logins[$login_cancel]['logged_in']) {
                    //login failed so no use continuing
                    $class->log_message("Login Failed: {$logins[$login_cancel]['username']} ", true, false);
                    $class->log_result();
                    return [$success_cancel, $success_book];
                }
                $logins[$login_cancel]['date'] = '';    //clear the date for booking
            }
            $success_cancel = $logins[$login_cancel]['class']->cancelReservation( $court_values['booking']->id, $location_id);    //actually cancel the event
            if(!$success_cancel) {
                //the cancel failed
                $class->log_message("***COURT CANCEL FAILED***  FOR $login_cancel ON $date AT $time_str COURT  $court_id", true, false);
            }
            sleep(1);   //wait a second before booking a court after a cancel
        }
        else {
            //we don't recognize the login account
            $class->log_message("***COURT CANCEL FAILED***  UNRECOGNIZED ACCOUNT: $login_cancel ON $date AT $time_str COURT  $court_id", true, false);
        }
    }
    //make booking
    if(isset($logins[$login_booking])) {
        $success_book = false;
        if(empty($logins[$login_booking]['class'])) {
            //not logged into this account yet
            $logins[$login_booking]['class'] = initialize_users($logins[$login_booking]);
            $logins[$login_booking]['logged_in'] = $logins[$login_booking]['class']->login(true);         //login as admin
            if (!$logins[$login_booking]['logged_in']) {
                //login failed so no use continuing
                $class->log_message("Login Failed: {$logins[$login_booking]['username']} ", true, false);
                $class->log_result();
                return [$success_cancel, $success_book];;
            }
            $logins[$login_booking]['date'] = '';       //clear the date for booking
        }
        //court booking_id is for a day of the week, not an absolute day so load the calendar for the day of interest
        if($logins[$login_booking]['date'] != $date) {
            $reservations_ce = $logins[$login_booking]['class']->getCalendar($date, $location_id);    //get calendar for this date
            $logins[$login_booking]['date'] = $date;        //save the date because we tend to book multiple courts on the same day
        }
        //get the usage string for this booking
        $usage = trim(str_replace($logins[$login_booking]['human_name'], '', $ce_string));
        $success_book = $logins[$login_booking]['class']->getReservation($court_values['booking_id'], $usage, $location_id);    //actually reserve the court
        if($success_book != 1) {
            //some booking error
            $class->log_message("***COURT BOOKING FAILED***  Error code $success_book: $login_booking ON $date AT $time_str COURT  $court_id", true, false);
            $success_book = false;
        }
    }
    else {
        if(!empty($login_booking)) {
            //tried to book with a login we don't recognize
            $class->log_message("***COURT BOOKING FAILED***  UNRECOGNIZED ACCOUNT FOR $login_booking ON $date AT $time_str COURT  $court_id", true, false);
            $success_book = false;
        }
    }
    return [$success_cancel, $success_book];
}










