<?php


require_once 'clubexpress_base.php';

class Clubexpress_class extends Clubexpress_base
{

    const URL_CE_MEMBER_NUMBERS_GET = 'content.aspx?page_id=81&club_id=' . CLUB_ID . '&actr=3';
    const URL_ADDITIONAL_INFORMATION_GET = 'content.aspx?page_id=151&club_id=' . CLUB_ID . '&mm=s&member_id=~&quick_link=1&actr=3';
    const URL_ADDITIONAL_MEMBER =  'content.aspx?page_id=147&club_id=' . CLUB_ID . '&actr=3';
    const URL_GET_REGISTRATION_PAGE = 'content.aspx?page_id=4002&club_id=' . CLUB_ID . '&item_id=~&event_date_id=255';
    const URL_WAITLIST = 'content.aspx?page_id=4077&club_id=' . CLUB_ID . '&item_id=~&arb=1';

    const SAVE_ADDITIONAL_MEMBER = REAL ? 0 : 1;
    const SAVE_ADDITIONAL_MEMBER_FILENAME = 'additional_member';
    const SAVE_ADDITIONAL_MEMBER_CSV = REAL ? 0 : 1;
    const SAVE_ADDITIONAL_MEMBER_CSV_FILENAME = 'additional_member_csv';
    const SAVE_CE_MEMBER_NUMBERS_GET = REAL ? 0 : 1;
    const SAVE_CE_MEMBER_NUMBERS_GET_FILENAME = 'member_numbers_get';
    const SAVE_CE_MEMBER_NUMBERS_FIRST = REAL ? 0 : 1;
    const SAVE_CE_MEMBER_NUMBERS_FIRST_FILENAME = 'member_numbers_first';
    const SAVE_WAITLIST = REAL ? 0 : 1;
    const SAVE_WAITLIST_FILENAME = 'registrants_get';



    function __construct($user_name, $password, $name, $DIR, $human_name, $log, $debug)
    {
        parent::__construct($user_name, $password, $name, $DIR, $human_name, $log, $debug);
    }

    public function resetEvent($event)
    {
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4004&club_id=' . CLUB_ID . '&&page_number=2',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($event['href'], 0, '', $headers);
        if (stripos($curl_result, 'Search For Events') !== false) {
            //looks like the right reload page
            return 1;
        }
        //register button is not present - see if we are not logged in
        if(stripos($curl_result, '>Member Login</a>') !== false) {
            //found Member Login button so we are not logged in
            $logged_in = self::login(true);         //login as member
            if (!$logged_in) {
                //login failed so no use continuing
                return -1;
            }
            else {
                //now that we are logged in try again
                $curl_result = self::getPage($event['href'], 0, '', $headers);
                if(stripos($curl_result, 'Search For Events') !== false) {
                    //looks like the right reload page
                    return 1;
                }
                else {
                    return -2;
                }
            }
        }
        return -3;
    }


    public function getWaitList($event)
    {
        /*******
         * this just loads the search page so add the post to get the members in the waitlist
        *******/
        $referer = str_replace('~', $event['item_id'], 'https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=~');
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            $referer,
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin'];

        $url = str_replace('~', $event['item_id'], self::URL_WAITLIST);
        $curl_result = self::getPage($url, self::SAVE_WAITLIST, self::SAVE_WAITLIST_FILENAME, $headers);

        $waitlisted = self::parseWaitList($curl_result);
        return $waitlisted;
    }


    public function getCourtSchedule($filename, $translations)
    {
        $time_translate = ['10:00' => '10:00am', '11:30' => '11:30am', '1:00' => '1:00pm', '2:30' => '2:30pm', '4:00' => '4:00pm', '5:30' => '5:30pm'];
        $rows = self::get_csv($filename, false);
        $days = ['Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday'];
        $day_of_week = '';
        $schedule = [];
        $strings = [];
        $missing_translations = [];
        $total_count = 0;
        foreach($rows as $row) {
            $first_column = 0;
            $row1 = '';
            foreach($row AS $index => $value) {
                if(!empty($value)) {
                    $first_column = $index;
                    $row1 = strtolower(trim($row[$first_column]));
                    break;
                }
            }
            if(empty($row1)) {
                //empty row so skip it
                continue;
            }
            //$row1 = str_replace(" ", '', $row1);  //remove space
            if(isset($time_translate[$row1])) {
                $row1 = $time_translate[$row1];
            }
            $found_day_of_week = false;
            foreach($days AS $day) {
                if(stripos($row1, $day) !== false) {
                    //found a day of the week
                    $day_of_week = $day;
                    $found_day_of_week = true;
                    break;
                }
            }
            if($found_day_of_week) {
                //don't need the rest of this row
                continue;
            }
            if(stripos($row1, 'START TIME') !== false) {
                //don't need this row
                continue;
            }
            if(!empty($day_of_week)) {
                if(!empty($row[$first_column + 2]) && !empty($row[$first_column + 3]) && !empty($row[$first_column + 4])) {
                    $row1 = str_replace(" ", '', $row1);  //remove space
                    $schedule[$day_of_week][$row1] = [];
                    $court = -1;
                    foreach($row AS $index => $string) {
                        if($index < $first_column) {
                            //ignore this column
                            continue;
                        }
                        $court++;
                        if($court == 0) {
                            continue;
                        }
                        if($court > 14) {
                            //comments so ignore them
                            break;
                        }

                        if(empty($string)) {
                            continue;
                        }
                        $string = trim(str_replace("\n", ' ', $string));  //remove CR and extra spaces
                        $string = str_replace("  ", ' ', $string);  //remove double or triple spaces
                        $string = trim(str_replace( "\r", '', $string));  //remove CR and extra spaces
                        $string = str_replace("  ", ' ', $string);  //remove double spaces
                        $schedule[$day_of_week][$row1][$court] = $string;
                        if(!isset($translations[$string])) {
                            if(!isset($missing_translations[$string])) {
                                $missing_translations[$string] = [];
                            }
                            $missing_translations[$string][$day_of_week][$row1][] = $court;
                        }
                        $total_count++;
                        if(!isset($strings[$string])) {
                            $strings[$string] = 0;
                        }
                        $strings[$string]++;
                    }
                }
            }
        }
        ksort($strings);
        /*if(!empty($output_filename)) {
            $csv_array = [];
            //$csv_array[] = ['String', 'Login', 'Description'];
            foreach ($strings as $string => $count) {
                $csv_array[] = ['String' => $string, 'Login' => '', 'First Name' => '', 'Last Name' => '', 'Description' => $string, 'CE String' => $string];
            }
            self::create_csv($csv_array, $output_filename);
        }*/
        return [$strings, $schedule, $missing_translations];
    }



    public function getRegistrationAndFees($url)
    {
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=2060492&event_date_id=237505',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($url, 0, '', $headers);
        return self::parseRegistrationInformation($curl_result);
    }

    public function parseRegistrationInformation($curl_result)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;

        //find the <a> that contains the link to Registration & Fees form
        $input = $dom->getElementById('ctl00_ctl00_close_date_time_picker');
        $close_date_time = $input ? $input->getAttribute('value') : '';
        if(!empty($close_date_time)) {
            //the date has '-' between the date and time and the time elements - example: 2023-09-16-06-00-00
            $temp = explode('-', $close_date_time);
            $close_date_time = $temp[0] . '-' . $temp[1] . '-' . $temp[2] . ' ' .$temp[3] . ':' . $temp[4] . ':' . $temp[5];
        }
        $input = $dom->getElementById('ctl00_ctl00_open_date_time_picker');
        $open_date_time = $input ? $input->getAttribute('value') : '';
        if(!empty($open_date_time)) {
            //the date has '-' between the date and time and the time elements - example: 2023-09-16-06-00-00
            $temp = explode('-', $open_date_time);
            $open_date_time = $temp[0] . '-' . $temp[1] . '-' . $temp[2] . ' ' .$temp[3] . ':' . $temp[4] . ':' . $temp[5];
        }
        return ['open_date_time' => $open_date_time, 'close_date_time' => $close_date_time];
    }


    public function getEvents($now, $day_count, $filename, $update=false, $save_csv=true, $echo=true)
    {
        $events = $update ? [] : self::get_csv($filename, true, $echo);

        if(!count($events)) {
            $new_events = parent::getEventPages($now, ($now + $day_count * 86400));
            $column_headings = [];

            //see if any of the events are not yet visible and if so do not include them
            foreach ($new_events as $index => $event) {
                $basic = self::getBasicInformation($event, $now);
                $event = array_merge($event, $basic);
                $reg_fees = self::getRegistrationAndFees($basic['reg_fee']);
                if(!empty($reg_fees['close_date_time'])) {
                    $event['date_reg_closes_date_time'] = $reg_fees['close_date_time'];
                }
                if(!empty($reg_fees['open_date_time'])) {
                    $event['date_reg_opens_date_time'] = $reg_fees['open_date_time'];
                }

                $events_partial[] = $event;
                foreach($event AS $key => $value) {
                    if(!in_array($key, $column_headings)) {
                        $column_headings[] = $key;
                    }
                }
            }
            $missing = [];
            $events = [];
            foreach($events_partial AS $event) {
                $event_final = [];
                foreach($column_headings AS $key) {
                    if(!isset($event[$key])) {
                        $event_final[$key] = '';
                        $missing[$event['date'] . ' ' . $event['title']][] = $key;
                    }
                    else {
                        $event_final[$key] = $event[$key];
                    }
                }
                $events[] = $event_final;
            }
            if($save_csv) {
                self::create_csv($events, $filename);
            }
        }

        $event_id = [];
        foreach($events AS $event) {
            $event_id[$event['item_id']] = $event;
        }

        return $event_id;
    }




    /*public function parse_script_manager_TSM($curl_result)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;

        //find the scripts
        $scripts = $dom->getElementsByTagName("script");
        if (($scripts->length == 0)) {
            return false;
        }
        $string = '_TSM_CombinedScripts_=';
        foreach ($scripts as $script) {
            $src = $script->getAttribute('src');
            $start = stripos($src, $string);
            if($start !== false) {
                $length_find = strlen($string);
                $end = strlen($src);
                $length = $end - $start - $length_find;
                $script_manager_TSM = substr($src, ($start + $length_find), $length) . ';';
                $this->form_signup_to_event['script_manager_TSM'] = urldecode($script_manager_TSM);
                break;
            }
        }
    }*/


    private function getElementsByClassName($dom, $ClassName, $tagName=null) {
        if($tagName){
            $Elements = $dom->getElementsByTagName($tagName);
        }else {
            $Elements = $dom->getElementsByTagName("*");
        }
        $Matched = array();
        for($i=0;$i<$Elements->length;$i++) {
            if($Elements->item($i)->attributes->getNamedItem('class')){
                if($Elements->item($i)->attributes->getNamedItem('class')->nodeValue == $ClassName) {
                    $Matched[]=$Elements->item($i);
                }
            }
        }
        return $Matched;
    }

    public function isFullPresent($curl_result)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;
        //find the results table
        $divs = self::getElementsByClassName($dom, 'content-text', 'div');
        if ((!empty($divs))) {
            foreach($divs AS $div) {
                if(stripos($div->textContent, 'Filled') !== false) {
                    $div_style = $div->getAttribute('style');
                    if($div_style && (stripos($div_style, 'display:none') === false)) {
                        //found a 'Filled' statement that is not hidden so it is filled
                        return true;
                    }
                }
            }
        }
        return false;
    }

    public function parseWaitList($curl_result)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;
        $waitlisted = [];

        //find the results table
        $tables = self::getElementsByClassName($dom, 'manager-table', 'table');
        if ((!empty($tables))) {
            $trs = $tables[0]->getElementsByTagName ("tr");
            if (($trs->length > 0)) {
                $first = true;
                foreach ($trs as $tr) {
                    if ($first) {
                        $first = false;
                        continue;
                    } else {
                        $tds = $tr->getElementsByTagName('td');
                        if (($tds->length != 6)) {
                            continue;
                        }
                        if(trim($tds[5]->textContent) == 'Waitlisted') {
                            $registrants[trim($tds[0]->textContent)] = ['date' => trim($tds[3]->textContent),
                                'registrant' => trim($tds[0]->textContent),
                                'status' => trim($tds[5]->textContent)
                            ];
                        }
                    }
                }
            }

        }
        return $registrants;
    }


    /*public function parseEvents($curl_result)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;
        $events = [];
        $count = 0;

        //find the div that contains the results table
        $div = $dom->getElementById ("ctl00_ctl00_results_panel");
        $trs = $div->getElementsByTagName ("tr");
        if (($trs->length > 0)) {
            $first = true;
            foreach ($trs as $tr) {
                if ($first) {
                    $tds = $tr->getElementsByTagName('td');
                    $results_string = trim($tds[0]->textContent);
                    $start = stripos($results_string, '(');
                    if ($start) {
                        $results_number = substr($results_string, ($start + 1), 100);
                        $count = intval($results_number);
                    }
                    $first = false;
                    continue;
                } else {
                    $tables = $tr->getElementsByTagName('table');
                    if (($tables->length > 0)) {
                        foreach ($tables as $table) {
                            $tr_subs = $table->getElementsByTagName('tr');
                            if (($tr_subs->length > 0)) {
                                foreach ($tr_subs as $tr_sub) {
                                    $tds = $tr_sub->getElementsByTagName('td');
                                    if (($tds->length != 8)) {
                                        continue;
                                    }
                                    if(trim($tds[6]->textContent) == 'Notification') {
                                        //not need to reset Notification events as no one can register
                                        continue;
                                    }
                                    /*if(trim($tds[3]->textContent) != 'Round Robin') {
                                        continue;       //debug test #############################################
                                    }*//*
                                    $registered = explode('/', trim($tds[4]->textContent));
                                    if(trim($tds[5]->textContent) == 'N/A') {
                                        $wait_list = ['0','0'];
                                    }
                                    else {
                                        $wait_list = explode('/', trim($tds[5]->textContent));
                                    }
                                    $maintain = $tds[7];
                                    $as = $maintain->getElementsByTagName('a');
                                    if ($as->length != 0) {
                                        $href = trim($as[3]->getAttribute('href'));
                                        $edit = trim($as[0]->getAttribute('href'));
                                        $string = 'item_id=';
                                        $src = $edit;
                                        $start = stripos($src, $string);
                                        if($start !== false) {
                                            $length_find = strlen($string);
                                            $end = strlen($src);
                                            $length = $end - $start - $length_find;
                                            $item_id = intval(substr($src, ($start + $length_find), $length));
                                        }
                                    } else {
                                        $href = '';
                                        $edit = '';
                                        $item_id = 0;
                                    }
                                    $events[] = ['date' => trim($tds[0]->textContent),
                                        'title' => trim($tds[1]->textContent),
                                        'status' => trim($tds[2]->textContent),
                                        'category' => trim($tds[3]->textContent),
                                        'registered' => str_replace("\xc2\xa0", '', trim($registered[0])),
                                        'max_registrants' => str_replace("\xc2\xa0", '', trim($registered[1])),
                                        'waiting' => str_replace("\xc2\xa0", '', trim($wait_list[1])),
                                        'max_waitlist' => str_replace("\xc2\xa0", '', trim($wait_list[0])),
                                        'type' => trim($tds[6]->textContent),
                                        'href' => $href,
                                        'edit' => $edit,
                                        'item_id' => $item_id
                                    ];
                                }
                            }
                        }
                    }
                }
            }
        }
        return [$count, $events];
    }*/

    public function parseReservationHistory($curl_result, $date, $time_str, $court_id)
    {
        $dom = new DOMDocument();
        libxml_use_internal_errors(true);
        $dom->loadHTML($curl_result);
        $dom->preserveWhiteSpace = false;

        $tables = $dom->getElementsByTagName('table');
        if (($tables->length > 0)) {
            foreach ($tables as $table) {
                $tr_subs = $table->getElementsByTagName('tr');
                if (($tr_subs->length > 0)) {
                    foreach ($tr_subs as $tr_sub) {
                        $tds = $tr_sub->getElementsByTagName('td');
                        if (($tds->length != 5)) {
                            continue;
                        }
                        $anchors = $tds[4]->getElementsByTagName('a');
                        if($anchors->length > 0) {
                            if($anchors[0]->getAttribute("title") == "Cancel Reservation Item") {
                                $string = trim($tds[1]->textContent);   //example: Court 1 Feb 12, 2023 3 half hour(s) at 4:00 PM
                                $string_elements = explode(' ', $string);
                                $court = trim($string_elements[1]); //get the court number
                                if($court == $court_id) {
                                    //get the date string
                                    $date_str = trim($string_elements[2]) . ' ' . trim($string_elements[3]) . ' ' . trim($string_elements[4]);
                                    $date_test = date('Y-m-d', strtotime($date_str));
                                    if($date == $date_test) {
                                        //get the time string
                                        $time = trim($string_elements[9]) . ' ' . trim($string_elements[10]);
                                        $time_test = date('g:ia', strtotime($time));
                                        if($time_test == $time_str) {
                                            $href = trim($anchors[0]->getAttribute('href'));
                                            $href = substr($href, 1); //remove the leading slash
                                            return $href;
                                        }
                                    }
                                }

                            }
                        }
                    }
                }
            }
        }

        return 0;
    }



    public function getAdditionalMemberData($filename, $update=false)
    {
        $values = $update ? [] : self::get_csv($filename);

        if(count($values)) {
            return $values;
        }

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=31&club_id=' . CLUB_ID . '&action=login&sl='];


        $curl_result = self::getPage(self::URL_ADDITIONAL_MEMBER, self::SAVE_ADDITIONAL_MEMBER, self::SAVE_ADDITIONAL_MEMBER_FILENAME, $headers);

        self::parseForm($curl_result);

        if (count($this->form_signup_to_event)) {
            //$this->form_signup_to_event['style_sheet_manager_TSSM'] = ';Telerik.Web.UI, Version=2018.2.710.45, Culture=neutral, PublicKeyToken=121fae78165ba3d4:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:53e1db5a:d126a8ef';
            $this->form_signup_to_event['script_manager_TSM'] = ';;System.Web.Extensions, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35:en-US:bc17b1ef-7a1b-49cb-a795-5f1c64597a53:ea597d4b:b25378d2;Telerik.Web.UI:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:16e4e7cd:365331c3:24ee1bba:ed16cbdc:c128760b:874f8ea2:f46195d3:19620875:33715776:cda80b3:383e4ce8';
            $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$hidden_export_button';
            $this->form_signup_to_event['ctl00$ctl00$hidden_membership_types'] = "1,2,3,5,6,7,8,10";
            $this->form_signup_to_event['ctl00$ctl00$hidden_subgroup_id'] = "-1";
            unset($this->form_signup_to_event['ctl00$ctl00$hidden_export_button']);

            //"style_sheet_manager_TSSM": "",
            //"script_manager_TSM": ";;System.Web.Extensions,+Version=4.0.0.0,+Culture=neutral,+PublicKeyToken=31bf3856ad364e35:en-US:ba1d5018-bf9d-4762-82f6-06087a49b5f6:ea597d4b:b25378d2;Telerik.Web.UI:en-US:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:16e4e7cd:365331c3:24ee1bba",
            //"__EVENTTARGET": "ctl00$ctl00$hidden_export_button",
            //"__EVENTARGUMENT": "",
            //"__VIEWSTATE": "TpGTmmTbZmAI0MHDhRaUyz4Kg9gQvGHKvqQ7y9bQ9RSsd7SYHcG1MlYySng/tJujKob2/UkGMiRk4EPTOLfHU55Kpkc=",
            //"__VIEWSTATEGENERATOR": "65E7F3AF",
            //"changes_pending": "",
            //"ctl00$ctl00$hidden_membership_types": "1,2,3,5,6,7,8,10",
            //"ctl00$ctl00$hidden_subgroup_id": "-1"
            $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
            //$post_vars = 'style_sheet_manager_TSSM=&script_manager_TSM=%3B%3BSystem.Web.Extensions%2C+Version%3D4.0.0.0%2C+Culture%3Dneutral%2C+PublicKeyToken%3D31bf3856ad364e35%3Aen-US%3Aba1d5018-bf9d-4762-82f6-06087a49b5f6%3Aea597d4b%3Ab25378d2%3BTelerik.Web.UI%3Aen-US%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A16e4e7cd%3A365331c3%3A24ee1bba&__EVENTTARGET=ctl00%24ctl00%24hidden_export_button&__EVENTARGUMENT=&__VIEWSTATE=TpGTmmTbZmAI0MHDhRaUyz4Kg9gQvGHKvqQ7y9bQ9RSsd7SYHcG1MlYySng%2FtJujKob2%2FUkGMiRk4EPTOLfHU55Kpkc%3D&__VIEWSTATEGENERATOR=65E7F3AF&changes_pending=&ctl00%24ctl00%24hidden_membership_types=1%2C2%2C3%2C5%2C6%2C7%2C8%2C10&ctl00%24ctl00%24hidden_subgroup_id=-1';
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
                'Content-Type: application/x-www-form-urlencoded',
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=147&club_id=' . CLUB_ID . '&actr=3'];

            $curl_result_csv = self::post($this->url_signup_to_event,self::SAVE_ADDITIONAL_MEMBER_CSV, self::SAVE_ADDITIONAL_MEMBER_CSV_FILENAME, $post_vars, $headers);
            $rows = explode("\r\n", $curl_result_csv);
            $values = [];
            if(count($rows)) {
                $first = true;

                foreach($rows AS $row) {
                    $array = str_getcsv($row, ",", "\"");
                    if ($first) {
                        $row = str_replace('"', '', $row);
                        $keys = explode(',', $row);
                        $first = false;
                        continue;
                    }


                    $array_row = [];
                    foreach ($keys as $index => $key) {
                        if(!isset($array[$index])) {
                            $array_row[$key] = '';
                        }
                        else {
                            $array_row[$key] = $array[$index];
                        }
                    }
                    if(!empty($array_row['member_number'])) {
                        $values[] = $array_row;
                    }
                    else {
                        $i=1;
                    }
                    /*if(empty($array_row['first_name']) || empty($array_row['last_name'])) {
                        $i=1;
                    }
                    else {
                        $name = $array_row['first_name'] . ' ' . $array_row['last_name'];
                        if(!isset($values[$name])) {
                            $values[$name] = $array_row;
                        }
                        else {
                            $i=1;
                        }
                    }*/
                }
            }
        }
        self::create_csv($values, $filename);
        return $values;
    }


    public function updateRegistrationAndFees($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['reg_fee'], 0, '', $headers);
        self::parseRegistrationAndFeesForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $old_new) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $this->form_signup_to_event[$ce_key] = $old_new;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change
        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }

        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //$actual = 'script_manager=ctl00%24ctl00%24ctl00%24ctl00%24the_whole_schmearPanel%7Cctl00%24ctl00%24save_button&style_sheet_manager_TSSM=%3BTelerik.Web.UI%2C%20Version%3D2018.2.710.45%2C%20Culture%3Dneutral%2C%20PublicKeyToken%3D121fae78165ba3d4%3Aen-CA%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A92753c09%3A91f742eb&script_manager_TSM=%3B%3BSystem.Web.Extensions%2C%20Version%3D4.0.0.0%2C%20Culture%3Dneutral%2C%20PublicKeyToken%3D31bf3856ad364e35%3Aen-CA%3Ae441b334-44bb-41f8-b8ef-43fec6e58811%3Aea597d4b%3Ab25378d2%3BTelerik.Web.UI%3Aen-CA%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A16e4e7cd%3A365331c3%3A24ee1bba%3Aed16cbdc%3A874f8ea2%3Ac128760b%3A19620875%3Ab2e06756%3A92fe8ea0%3Afa31b949%3A4877f69a%3A33715776%3Af46195d3%3A490a9d4e%3Abd8f85e4%3B&DES_Group=&changes_pending=&ctl00_ctl00_event_button_control_panel_event_window_manager_ClientState=&ctl00%24ctl00%24member_id=6698144&ctl00%24ctl00%24member_name=Suzanne%20L%20Richards&ctl00%24ctl00%24responsibility_text=&ctl00%24ctl00%24is_admin_checkbox=on&ctl00%24ctl00%24is_primary_checkbox=on&ctl00%24ctl00%24show_contact_email_radiobuttonlist=2&ctl00%24ctl00%24show_contact_phone_radiobuttonlist=0&ctl00%24ctl00%24show_contact_cell_phone_radiobuttonlist=2&ctl00%24ctl00%24notify_on_cancellation_checkbox=on&ctl00%24ctl00%24panel_completed_checkbox=on&__EVENTTARGET=ctl00%24ctl00%24save_button&__EVENTARGUMENT=&__VIEWSTATEFIELDCOUNT=4&__VIEWSTATE=1oP4sXtSXjCbNohWqD%2FdL5mgcaL5R1nxMRaE%2F0kJ3ANwrcmuDr%2FsnfcZSoMUiUk2rKxj1yFqdVGraybNyQJY5Q1x3YvCZa458WOuVEGmna%2FujQeWLvLybW42%2B6NMfApGU3TQvH6%2FvfcKzKTdwNhL53eNzDAUtA%2B0i0qWmNWXhLwX9Y6ykVya8GEcLgIf24bSO8BuP8JBLLBaNPPkmi5a9EjnXgbIPzj50X2u1VFq%2BoxnxpVASMjTYYFEp4FeKJ2eYcmytdN%2BSjoUKLeYYKQXIIMeMZ0zjAS%2FluYjCmCeBxIjkFlRXKmTwB9QsoLsYOxZdWUM1jtTgFXdujOY123n%2B2b15mH7fpjPkiYvyj0xVwspPV8WcyKtBvezlml9Y9kaX%2FgsfRs8786Na0f3gBrUfAb1vjxg20MNEwVIkPThpUSDjWg%2BlGc0mAKQlJuEOdSzK9EODSIv%2FTWfQoc%2F08JqHeshsyryPinmirQILcwCd3kw8G9M%2FCRn8buXnrMIJefjSHmhgZokVzQLKvphWKRAEFEmc0XoDeU3R0hcjzE2jVkgF1KD9ap4SMNuX7neG1y0DfeXbO%2FEbk3YiTDMeXUc7b6hb8h86CNJbbyLq2vqf1iOqvfjUjw30VwXas40YmrLDEhrW0Zydyh8N0cfkTNbiAJYq8ZXHtoK01MH0SuoW2CQGfkqU7Rc7jNtY1099X8M8YASE2K1Dy6K2FIPZTYX7FreTlHjTLNwLgS%2BnPUTevwFMAm4jyvhl3d0l9SblfDwYMg3%2Fif3OLVwMn7sFyu%2FPGav125Nq9f4eObNKZpMDr8Ftrk5%2BxbfdeKUOLCu0U3lxdpyhlvNTOgOehqzr58xVQWaTZUeNWhNOT0MXYWu3wue9Ij0Ym7uw7q3a8WRCS7WPHQfCL8g%2B8KcsBOTpsrG0%2B6269hxswJGUuOdjdXk1j02jJeTKhDThuDj2SchanwIstI9TIAy8YbgwhMG7H%2B1p0ilYYKp%2FuyQ9Q%2FE5sMnepz3Ouw0l5eQbUi4TuHwQHMzjntuHaljhclWrnwpF1xQ2Vx5HnUn4Y%2F0D2FUXjKbxTq94ZW0fn4PeU7k%2Bxn%2B%2BS5nK7e31%2Fir48bnp%2FkjOnnMxfnfZ97%2Fm3VDZw180ByUDuJuKsuKfu2C2XjN%2FA8WxQZsxFXxblRt0Ww2eTx0VKt2NuDpwo%2BkJF0FJoIF7cTE2W606mXrWHhjui%2FEpg56gvrYbSnYWzUcREH91VX4sxwClEtiPWYTSaVQKl1zFcg1AkXKsdHsE0xGEnWOCI1xsAw4ji1Vg%2F1xj%2BqEn4xG%2BFlz53IV95nJHQSMM%2FsU8Q33ht3w%2Bt0iX45gZVasBWNg04LENDEWWWU4tztkFRU8%2BSRzXbVxpNk8N0gawml3a1aqj8L38eY6SfQRvnE7%2BMwr5MzQJm0X2dngmX5acw%2FkBJcTpZWOy%2B0nIJsNitACs0VVmcZKxpB7MBC9xW2UasXqOmuO8s7NNxTy2fTwi8pSCShyiCbkb4eQc1gRR9OFRICzM8ypNb0XrnKvI%2BVBEDOSIMr%2B8%2FmGnNqeEdufcGrfp7JaZTLASqaBoXPvWwsqMaaWjY6mZghnIiCrUj6dlqHy77EYm6PUIcXCYlpU%2BOdYLpLh83XBAEosBAFR7H5qgRbZFyTRwZVyPc8dpP5Ig2lxHJl9HpI4JdOHiTrcCrvqJ2GMTSzrgMukLY%2FECTiQz19%2BSrTvpQRtVZQaM6rRQMdQ7RAfIEJISGAi0RJFr1ZsR2rMytUGTDJp%2FUH4n%2BwLOqQYA5AD2XrDgm2gk6oAd8Nv3Qzxdf%2FzDC6LMdKEp5sAy%2Ff2bvyFIjnim4eiVAKVQJjBIuvcncirqckB%2FW60WgkFCjb4PPGTRkmykIzn36MqzMejjBSCSSfbSNR1u7xD5UivyKEjR5RhZxEDS8mt9QBdzgkVsGzGTgX20w8aPu8Sho13z2Hg7x0QSCY5F4TMVZrMVUzyTSTV%2Fl%2BSYpa4ij8uQeoToyNrO6XZTF1k2iK9i3lBukQgPho2FRaHvcJx7jZloQgfd2Ey5FeAeF2vgYpu%2FHm6&__VIEWSTATE1=1%2FWMvQSgL%2F5mp1BYZ2X343ZbMEs4K9WWVfQbTaZKmLdbRfsk1Io%2Fn2XKZDn8X2Scs7uQ7EKEt49xd3IuXP9jK5AM6Hiavp%2BcSY0QIOR89VVM4WOY9Pe5Q5EhUTFuhbBGhelmXKDWNsVYZ2c1zC7TIVTIuEcs7B5AhCXZUqedGR6k28wC6sWetPTsgX9uUBD0Q1HejeVJ3TytKQCXXLrozOMcIiadLPUy%2F8QXj%2Fg0exkOMZE9TYc7Qp6t9%2FcsxPd%2F4%2BISNsZ8amCUFBp9EmWj5s6b61fxojvVAqQsViAFRoyKc8IJ%2BqQVaX25YUOiIYI%2FiRbkqTgeoixWonpMKB3YqciiCAoK8dbrg5nLHzS5EPtMyIgFv0oV4nYHhlLmJ7AhjErxYtWwOfSD9g16vX%2Fc442uSBZ%2Bk2OSWDUHw2GBct7fHtJBC%2FQ65UcfAZBmaK0wkgcGES3AJUWLDNkAtYdkTGS76hS6ZVmvGep7M%2BIUPEyuTyEaGT28tRdZqbPllah8wxVMWA%2BUi5rwMPvdDVvbNUyDOKTlIQEQWDveOwAYL6LFoGvLBcdjGWsYUUBXoN8Z3AkHJdYLjk%2FX0gvUhDoHjuhaLtwEdB6ASOs0L6TQaerhPH16ami2WWxujdSvj6wNA8VrV7e9m%2F7NIZvi3RjGG%2Behn1Deg7zCx9kPABHjsrIVPeTiWeC171V%2BjcjpaL%2Fr1mTdb%2B212WFbiju8b%2FEGuUut0pVo4LYWziUspt7zcE6hYHAEqdSq68MaK27rREhnVcygPez2YFFr6f9e7O%2FNbUJc1YQL%2FZcPEcmAiXky4fKpKH6P1HHBovaJLOOSHlRe2OVLTAdpKDCkJ1iko1G2p9tXXhMZophKvimSry7QqXle0Myj3dC%2F1efQ5LEhACnHlgnaJnq5dxE1dW%2B8ES7Ffn5RvyWXdTbGYK8OuZRJ8kPKYnZltHQaFzvHuz8TxO0%2BZYcf7Higuk41TRZZNh6i8yd%2BFRu2I0q0KhePkwiauv4nvw9VVekqw%2BAPZ9S%2FcVnl2tpl23z5oUlrpMFHPE1XuF%2BCBDy8mviDHXxz2CHzPO3K%2Fb3HehoD4Wx%2FjpnmjKyQNheFqni3rIA%2FPIMBRTPISogfu%2Bh6wzius2RwBugxL2JoRMNdiVgADaCsSxueWN%2Fedstim73oc0OvRmFUc3ZIYiKRvmk4ZGx7ddBKNIRjRMdtJnm6yUGxNYDoZ4v5bOkg9dw4HLHllri9gyLZAn9DQqQ7lwiw6QOl2%2FEJTLmQiaJgW%2Fp4fqMivSBmCWr0I1BjQYRDiwhd3Vtsrup3JCVWcZJDg9LKT9W5xkRj3MYResVIZlF8mE6cbYmJ3b6og1QS%2BZFvDATOUF1yukoS3Z2cUpDbGLHLfLu0RJsGJPOgbswVrkOQr2khOEftmdWjhod6maO%2BNuHpXuncZwa4xRHCG2o0qEcLkl8G06K1L0pb2Dzb1wBL92janaKvq9kAekQR6tWKw87B%2Fucy4e0of7VVdKci%2BiEbS3zT%2FXUge%2FsV%2Fhhv%2FEt1gWjv0ElKJonzblpuS4XtOXbS9ZW%2FAJ8rAJXdwWZrNiHOTWTBtLmzb5wY80eMOmoUc0hbuapI7HhtYr3Ie2hgho5qUWKaOkLPzMhq%2FlbCOsoYqkZy8cK4wMl1twdizCen6ao0w1aTiDWR7B0sBBQPEWVnQfEpq3Rlf%2F2X2OR7LMV0hnuo%2BBXGx%2BghF2TMwGR6kUMKeaQYJa5x%2FuuDUGTTA6Eoj2JY0wuYQuH0%2BFvJw%2FGC5%2F5nOr9rMovtq6nVGR6JJNzMk%2F%2FPCq7c%2BkRfPX0g1JvUqBnu8Yk8AKd4ukdJqHEnoGTBqQsjB9%2BHwWnmnCnTX%2FbJI3w3sVrnZjeDIjUFYjxWCxPFMewEwAO1Wy2vOxC4D7rH5gzPgkhOSnNx%2FrccsEjRXjYp%2FDw77VpNO2tW2u%2BghnjJ1ewFz9a0S9MqPwS%2FTp0rShIXVhgwr098uZe0qxYTWOd4e8A0FDkhCo36YQhVIgcGAoxhUR2D4IlpnUQPqMvGV0JxXiNp8D58PLi0vekGgjf9Bt0iUzW6&__VIEWSTATE2=yqh6M9gqK5iFpCgGJ9PC4%2FC8Cr2t6kwVktCHuDu%2BLtskdOVROOdeEZpJl%2BxhsWPzb2BY9y1EhjQZZ4fplozVlxl9lk%2FgMFHA%2BMauDDzh0gd7ho5iSX8qzz5W82q7t8XD6oZM38geMFS1qtb%2BtbVPqof5WxmdXxR%2Fj5Da8RH0%2BHNzvcTYtWTl7ZuL0zPhfi6e%2FCyJWgquKKCUkp2asTs9hCfGj0R8X7kpjLg%2BwU99CzDiN%2FPAUvfx4P4dyZs7fWKG4sq5pg13dHCYc8R9Ds1CsWfSU6PkgMEViiWFft8qfRLI16ecsryhvyHMc95f8zPZomh0RFTiTlJGQsZYo8ocgpM1QpGyZOEgN80uPUg6qQFBlWLx9Buf7KMhE0NBFDxIEVRbMeZCgnasVczFtXOHxGqEfpORKExoUmasaPVhQYbpz5uPikxjTTGcKP%2Fzz5071ajrAai7ECIxoh2OIocHui3lGfsVF13oA72LaktYP6r9b8Z9YSMCzxyrc3JPZG4CazKyHAAIIAk1hUm13hFRlgdnjw03%2BS1SyF5%2BRgV32mV2cV6E6dcKqfq8AA2VgEa6NldNvHLl2ZXTuey9ZmvsWv1rKs6XAUN6P711iLwLoCI0bBfQkt9rR3mdFX8Yshm6vM737KHS0hzb5RIUzDy15%2BFuL8IhMOO8cy0MkW%2F2mKEqkboqIJaqc%2BLBFPpa5XHYueIlLelCxAJYDjPaTJnDKD%2BSXa60Rt8%2BOk97kC39nbrbPByNJRxBvsL4lILDMrJ%2FM31GbCviLl2CJv2bUXVHBTM4n0IhJehgeOnXGX2EPuCE8lh0Tkie3PNgKJCtphJXag5lY4bTeKlCJdEG3W%2BH0Sy3ZSNR%2FHU4WSP7zpexeRZyjRSjcIXrj0WUMh%2FiEoxQ7zwMgGIOz%2F2%2Bw9COKIvQtK21zTGVDUIMmC5o3DDQud9WOV2v%2FB0AktmcMkA4goPEt1Cho4a%2F9Hk%2BnhVJbU7ndL7iN9orj4UJjU4dCkQUmzMQ5Cdj%2B7N0t4h1yZIbO3i9kd6Qn6P8pULqdQ5dwSwUWLvtsYm5dgbKQRUAfjOZEBtFhEFIGrWTWH9jLAI0yqdrIaG2u8YJZRjATc8YqiYF6yDbAVyay5oDVwloOS9N0mYRX58Y2%2B%2Fg8CJ9pdzwsZbVJnnSrCSJdylLK%2FD5eaO271CMhSL1nFIwW0LDU7CgmHXslu8v2Rp9ce1b5E71bDN5asrhs34b3PAjRDReDhoEhIO5epHiqTLl5E8yAR%2BGPXpaIwLI5iKiE9NCA3%2FskZtEspIf4cl%2Fn5GTwgEDDliRKLqjMlsPVB4jxI0R0lJr901qZigUkIwovwofz06Br5RIGWjnjNewCtD7KdbCxEKyLeFCJt8H4GA5vwejYGEg3pIoblRBtRGZsEquVBTrcRQGDYjh2HPhJgrnMW0VCZHJIYYivgjW%2BAzsryKGjtoVZMIk9%2F0ErWvFJb1EqXPFHVnApkGHfZy5Gs5OmZwC0XaEL83iG6BJr5lS91a4u5pt9TvfdQWYDMJND6f8jQmdZpGiOb3koJhou8LSnDdVWzmSUC8XxgGRryKpIG9TvBUXJ1LDIKaRqQKR69af%2BPGX2u4uYIHKIOeRk0mWrdVPoI3ni2p5FD9CFyITcWWejA83VGTrxO2JVK9RDuPD8fatWJf6ViWInGSw%2F6D2IulT35RhSOdKpzS2I6ZJmyA8PE1wvAU9j2v2ZyjA%2BDj%2FnqyVB3N5Hq1oTw%2F7KUhaTDBq0AMMinXGkg%2FQFQUXfSwEJL5a%2BuG4s%2BX7IMzibjIRKJE0fuTt4JTLYgek21Z%2BSGSU92dyXwJSMGpFon8yFjO6lfxiH013W%2FfuFVtAjEEjlnxhukkOLbF%2Bu%2BUOC89mOEW9BCAuSRWjXQom0K76%2Bh2J4iZPLrOpB%2BRy7O5oqUq2Ym5vyk%2BvIy7LMhqW2IjupsLioQ5nH%2FThPV%2FYKb62yQDgngNgc1%2BFGRDn%2FRIqRWa6ldwdW3FcvX976ehxSCad4e2ZNdDEaQOlidcynqVfN1RXJwbw4YgEaunGQg2XHAehYWFuScYD&__VIEWSTATE3=ICmrs7zidAkJtXKQrsWg1yl4v570qSdrf4bmSUnH%2B%2B8MwDSiQq4waSP3AvJ%2BTUTSV2WPw3HtRgMGDshTiz2lB%2FDqB%2BBomEMskUHi1i046iFVBJ4lVpMRMxWuqbttDDJxVkW5rzUCWpJSd2j7iRrXUPLEACeX0tla3PJD%2F2LKp7pA1Urh0W9EjMVBoxUxGpUxT9GNMrpvRNTWhEIaXTlEPG6pAKqOVcpN38TF177uHL5ldvQ1rwUZt0hphK8WjB%2FvVl2i%2BNsZn6TE%2BzE%2FZ32avrnsIGCIit1lNp37IN4vhZcsZlQ2HBL%2BeK%2BUDt0YDrDASiqG5qMtyc4rgQXfychnObn%2FSSvWJXNvJE2ptEqbdhhXbfFU4GmSD6CqQ8Qj65tI%2BsuEaqKdvoOqoQa%2F5NPCRkyEBY1c54YvQvdNVQGOpxHWYJO7cud%2BnhMwBnt6i3FXVoIEKD4EosrlelmEVkBa6NVIdq27o4RrdypxHV3Tg44w%2FAYoCtaqyALfr19pGDm7H7WIy%2BkIESvfoghyeRJgiIqF%2F%2FzHotp9UOjSZTR7X3rBMTE5ybX213TurJ89McSXtRBM6CR7bvYeLZCAFh0U%2BrhKrqbazHO8JdpTkeEHbupS61MlqlXC5EXB5%2FJJezJfBT4sHRCDJOxJzIOpkQtQ6NTKUIUUBoLIMy6YkvhviRoltitwPpZ6IS2HaYarmG0866C5UBZmQgz8UZMVwYNE3EMOJE8EOqULgRgnGYcREinbnoHGM1VUi3qU3vfZ%2FmyPXqA39gBywT09pmnRKClXO666946Y9IvbwMav46Y8tF9hZQvWDnVYyhanxpLg0VD3fOwJ%2FyYpb93sgA%2BOgY2GpNrAXhtuSZOX%2BrVD5EufOC0PWoAOWyz%2B2qq5XdHDJNqa%2F5GT1EWlOLkLYgWfsYy8MOAFewe3I5pXT8458XKLikxxW0Mskffq8p%2BhaaJVPS3JP%2FEwToSgvbtGP4cD2hBWV0ZYLWQ5Y5Io4d8UAPqQjiKdRu3W85q075MOaYGI7FVJyI7PoL257XgijYmhP8umRr98kCPcOv3brFFxnWgUXsCVZ2KcpsQGXqHZrSKcbTHNubhj0KSR%2BYENOIs53OAWbwouXEdqMR6tXbx9J7U2aR8p2C%2BUHq2BzmnuBIbKW106aK0Z2xnxdhsk%2Bw%2F%2FgHzmDX3rkV4XaJRU5fSWztDqGriC%2FmD8I2v6WJRjQHF27NexOhSXPUfPebY9oBj%2FCUy17JKn3vWDdiTs07fBJkt%2F%2BtwcbYQv9XSdE3KTHwvdHpSvZRG8xKUlUf%2FFKepzT76ssvHvap4xWo6P3LldT%2BYf3Xm8saMso46j9YYnz63FyhHrZhGccrypBXxG58yz81gxRF9N05hhRNNihbgUPKmZtJEt3EvHn8qNOK12ik0dux5YUxNQf5%2FlwdqNVA0RGoxCmzIY1KpM7f23CPFBBmOtRf1gfvPfM2HeHOICOYy4ThODUpaA9cuhESmFU6ESdA2IgUwU%2BjQB%2Bq8jClc0XzXujfVd0jU%2BuaL8oAARBDhoACAc0S7KIGLAWxsSjIgovgTf%2FVoBUQnEI6k4unabWbw6EQywqbTVRXs7qiL6f1LteLfrEWJs8ezBJI%2FJb2FQ8NB5YX702z%2F6j%2F%2F5V0G%2B2UlADOFajOIKsaKidNMIEPgv6e%2FI5ubUUhPiJTZiKKe396bpwvnmoOk48wex7jHRGHK3gwiAZ7%2Bl5Ddu1p07Ngms3zF8qHzlG%2BqDAyrx827A%2F1WI6JYgxLuu9fTLHANYCNKm1B4CC4ZgT99Bnivpq1mm9er6v0%2FDJ61uApZAQF7yCpDuicZfv%2F3VxquBRRJTNb2JhlTbG18%2Fb2noE0j2BvHBS79PFu5O8k1Rmbwvu31P89FUbCR2c4c%3D&__VIEWSTATEGENERATOR=65E7F3AF&__ASYNCPOST=true&';
        //self::testPostVars($post_vars, $actual);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4060&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded; charset=utf-8',
            'X-Requested-With: XMLHttpRequest',
            'X-MicrosoftAjax: Delta=true',
            'Sec-Fetch-Dest: empty',
            'Sec-Fetch-Mode: cors',
            'Sec-Fetch-Site: same-origin',
            'Priority: u=1'];


        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if((stripos($curl_result_post, 'pageRedirect') === false) ||  (stripos($curl_result_post, $event['item_id']) === false)) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $curl_result = self::getPage($basic_info['reg_fee'], 0, '', $headers);
            self::parseRegistrationAndFeesForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    if ($this->form_signup_to_event[$ce_key] != $old_new) {
                        //mismatch of new value
                        return -2;
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }


    public function updateRegistrationAndFeesGuestSettings($event, $verify=false)
    {
        $guest_settings_control = [
            'ctl00$ctl00$non_member_company_setting_dropdown' => ['name' =>'Name_member', 'correct_setting' => 'Do Not Show', 'update_id' => 'ctl00_ctl00_non_member_company_setting_dropdown_ClientState'],
            'ctl00$ctl00$companion_company_setting_dropdown' => ['name' =>'Name_guest', 'correct_setting' => 'Do Not Show', 'update_id' => 'ctl00_ctl00_companion_company_setting_dropdown_ClientState'],
            'ctl00$ctl00$non_member_address_setting_dropdown'=> ['name' =>'Address_member', 'correct_setting' => 'Do Not Show', 'update_id' => 'ctl00_ctl00_non_member_address_setting_dropdown_ClientState'],
            'ctl00$ctl00$companion_address_setting_dropdown' => ['name' =>'Address_guest', 'correct_setting' => 'Do Not Show', 'update_id' => 'ctl00_ctl00_companion_address_setting_dropdown_ClientState'],
            'ctl00$ctl00$non_member_email_setting_dropdown' => ['name' =>'Email_member', 'correct_setting' => 'Show', 'update_id' => 'ctl00_ctl00_non_member_email_setting_dropdown_ClientState'],
            'ctl00$ctl00$companion_email_setting_dropdown' => ['name' =>'Email_guest', 'correct_setting' => 'Show', 'update_id' => 'ctl00_ctl00_companion_email_setting_dropdown_ClientState'],
            'ctl00$ctl00$non_member_phone_setting_dropdown' => ['name' =>'Phone_member', 'correct_setting' => 'Do Not Show', 'update_id' => 'ctl00_ctl00_non_member_phone_setting_dropdown_ClientState'],
            'ctl00$ctl00$companion_phone_setting_dropdown' => ['name' =>'Phone_guest', 'correct_setting' => 'Do Not Show', 'update_id' => 'ctl00_ctl00_companion_phone_setting_dropdown_ClientState'],
            'ctl00$ctl00$non_member_mobile_setting_dropdown' => ['name' =>'Mobile_member', 'correct_setting' => 'Show', 'update_id' => 'ctl00_ctl00_non_member_mobile_setting_dropdown_ClientState'],
            'ctl00$ctl00$companion_mobile_setting_dropdown' => ['name' =>'Mobile_guest', 'correct_setting' => 'Show', 'update_id' => 'ctl00_ctl00_companion_mobile_setting_dropdown_ClientState']
        ];
        $corrections = [
            'Show' => "{\"logEntries\":[],\"value\":\"1\",\"text\":\"Show\",\"enabled\":true,\"checkedIndices\":[],\"checkedItemsTextOverflows\":false}",
            'Do Not Show' => "{\"logEntries\":[],\"value\":\"0\",\"text\":\"Do Not Show\",\"enabled\":true,\"checkedIndices\":[],\"checkedItemsTextOverflows\":false}",
            "Show and Require" => "{\"logEntries\":[],\"value\":\"2\",\"text\":\"Show and Require\",\"enabled\":true,\"checkedIndices\":[],\"checkedItemsTextOverflows\":false}"
        ];

        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['reg_fee'], 0, '', $headers);
        self::parseRegistrationAndFeesForm($curl_result);

        $form_signup_to_event_old = $this->form_signup_to_event;

        $changes = [];
        foreach($guest_settings_control AS $id => $values) {
            $guest_settings = trim($form_signup_to_event_old[$id]);
            if($guest_settings != $values['correct_setting']) {
                $changes[$values['update_id']] = $corrections[$values['correct_setting']];
                $changes[$id] = $values['correct_setting'];
            }

        }
        if(empty($changes)) {
            //no changes required to return
            return;
        }

        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $old_new) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $this->form_signup_to_event[$ce_key] = $old_new;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change
        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }

        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //$actual = 'script_manager=ctl00%24ctl00%24ctl00%24ctl00%24the_whole_schmearPanel%7Cctl00%24ctl00%24save_button&style_sheet_manager_TSSM=%3BTelerik.Web.UI%2C%20Version%3D2018.2.710.45%2C%20Culture%3Dneutral%2C%20PublicKeyToken%3D121fae78165ba3d4%3Aen-CA%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A92753c09%3A91f742eb&script_manager_TSM=%3B%3BSystem.Web.Extensions%2C%20Version%3D4.0.0.0%2C%20Culture%3Dneutral%2C%20PublicKeyToken%3D31bf3856ad364e35%3Aen-CA%3Ae441b334-44bb-41f8-b8ef-43fec6e58811%3Aea597d4b%3Ab25378d2%3BTelerik.Web.UI%3Aen-CA%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A16e4e7cd%3A365331c3%3A24ee1bba%3Aed16cbdc%3A874f8ea2%3Ac128760b%3A19620875%3Ab2e06756%3A92fe8ea0%3Afa31b949%3A4877f69a%3A33715776%3Af46195d3%3A490a9d4e%3Abd8f85e4%3B&DES_Group=&changes_pending=&ctl00_ctl00_event_button_control_panel_event_window_manager_ClientState=&ctl00%24ctl00%24member_id=6698144&ctl00%24ctl00%24member_name=Suzanne%20L%20Richards&ctl00%24ctl00%24responsibility_text=&ctl00%24ctl00%24is_admin_checkbox=on&ctl00%24ctl00%24is_primary_checkbox=on&ctl00%24ctl00%24show_contact_email_radiobuttonlist=2&ctl00%24ctl00%24show_contact_phone_radiobuttonlist=0&ctl00%24ctl00%24show_contact_cell_phone_radiobuttonlist=2&ctl00%24ctl00%24notify_on_cancellation_checkbox=on&ctl00%24ctl00%24panel_completed_checkbox=on&__EVENTTARGET=ctl00%24ctl00%24save_button&__EVENTARGUMENT=&__VIEWSTATEFIELDCOUNT=4&__VIEWSTATE=1oP4sXtSXjCbNohWqD%2FdL5mgcaL5R1nxMRaE%2F0kJ3ANwrcmuDr%2FsnfcZSoMUiUk2rKxj1yFqdVGraybNyQJY5Q1x3YvCZa458WOuVEGmna%2FujQeWLvLybW42%2B6NMfApGU3TQvH6%2FvfcKzKTdwNhL53eNzDAUtA%2B0i0qWmNWXhLwX9Y6ykVya8GEcLgIf24bSO8BuP8JBLLBaNPPkmi5a9EjnXgbIPzj50X2u1VFq%2BoxnxpVASMjTYYFEp4FeKJ2eYcmytdN%2BSjoUKLeYYKQXIIMeMZ0zjAS%2FluYjCmCeBxIjkFlRXKmTwB9QsoLsYOxZdWUM1jtTgFXdujOY123n%2B2b15mH7fpjPkiYvyj0xVwspPV8WcyKtBvezlml9Y9kaX%2FgsfRs8786Na0f3gBrUfAb1vjxg20MNEwVIkPThpUSDjWg%2BlGc0mAKQlJuEOdSzK9EODSIv%2FTWfQoc%2F08JqHeshsyryPinmirQILcwCd3kw8G9M%2FCRn8buXnrMIJefjSHmhgZokVzQLKvphWKRAEFEmc0XoDeU3R0hcjzE2jVkgF1KD9ap4SMNuX7neG1y0DfeXbO%2FEbk3YiTDMeXUc7b6hb8h86CNJbbyLq2vqf1iOqvfjUjw30VwXas40YmrLDEhrW0Zydyh8N0cfkTNbiAJYq8ZXHtoK01MH0SuoW2CQGfkqU7Rc7jNtY1099X8M8YASE2K1Dy6K2FIPZTYX7FreTlHjTLNwLgS%2BnPUTevwFMAm4jyvhl3d0l9SblfDwYMg3%2Fif3OLVwMn7sFyu%2FPGav125Nq9f4eObNKZpMDr8Ftrk5%2BxbfdeKUOLCu0U3lxdpyhlvNTOgOehqzr58xVQWaTZUeNWhNOT0MXYWu3wue9Ij0Ym7uw7q3a8WRCS7WPHQfCL8g%2B8KcsBOTpsrG0%2B6269hxswJGUuOdjdXk1j02jJeTKhDThuDj2SchanwIstI9TIAy8YbgwhMG7H%2B1p0ilYYKp%2FuyQ9Q%2FE5sMnepz3Ouw0l5eQbUi4TuHwQHMzjntuHaljhclWrnwpF1xQ2Vx5HnUn4Y%2F0D2FUXjKbxTq94ZW0fn4PeU7k%2Bxn%2B%2BS5nK7e31%2Fir48bnp%2FkjOnnMxfnfZ97%2Fm3VDZw180ByUDuJuKsuKfu2C2XjN%2FA8WxQZsxFXxblRt0Ww2eTx0VKt2NuDpwo%2BkJF0FJoIF7cTE2W606mXrWHhjui%2FEpg56gvrYbSnYWzUcREH91VX4sxwClEtiPWYTSaVQKl1zFcg1AkXKsdHsE0xGEnWOCI1xsAw4ji1Vg%2F1xj%2BqEn4xG%2BFlz53IV95nJHQSMM%2FsU8Q33ht3w%2Bt0iX45gZVasBWNg04LENDEWWWU4tztkFRU8%2BSRzXbVxpNk8N0gawml3a1aqj8L38eY6SfQRvnE7%2BMwr5MzQJm0X2dngmX5acw%2FkBJcTpZWOy%2B0nIJsNitACs0VVmcZKxpB7MBC9xW2UasXqOmuO8s7NNxTy2fTwi8pSCShyiCbkb4eQc1gRR9OFRICzM8ypNb0XrnKvI%2BVBEDOSIMr%2B8%2FmGnNqeEdufcGrfp7JaZTLASqaBoXPvWwsqMaaWjY6mZghnIiCrUj6dlqHy77EYm6PUIcXCYlpU%2BOdYLpLh83XBAEosBAFR7H5qgRbZFyTRwZVyPc8dpP5Ig2lxHJl9HpI4JdOHiTrcCrvqJ2GMTSzrgMukLY%2FECTiQz19%2BSrTvpQRtVZQaM6rRQMdQ7RAfIEJISGAi0RJFr1ZsR2rMytUGTDJp%2FUH4n%2BwLOqQYA5AD2XrDgm2gk6oAd8Nv3Qzxdf%2FzDC6LMdKEp5sAy%2Ff2bvyFIjnim4eiVAKVQJjBIuvcncirqckB%2FW60WgkFCjb4PPGTRkmykIzn36MqzMejjBSCSSfbSNR1u7xD5UivyKEjR5RhZxEDS8mt9QBdzgkVsGzGTgX20w8aPu8Sho13z2Hg7x0QSCY5F4TMVZrMVUzyTSTV%2Fl%2BSYpa4ij8uQeoToyNrO6XZTF1k2iK9i3lBukQgPho2FRaHvcJx7jZloQgfd2Ey5FeAeF2vgYpu%2FHm6&__VIEWSTATE1=1%2FWMvQSgL%2F5mp1BYZ2X343ZbMEs4K9WWVfQbTaZKmLdbRfsk1Io%2Fn2XKZDn8X2Scs7uQ7EKEt49xd3IuXP9jK5AM6Hiavp%2BcSY0QIOR89VVM4WOY9Pe5Q5EhUTFuhbBGhelmXKDWNsVYZ2c1zC7TIVTIuEcs7B5AhCXZUqedGR6k28wC6sWetPTsgX9uUBD0Q1HejeVJ3TytKQCXXLrozOMcIiadLPUy%2F8QXj%2Fg0exkOMZE9TYc7Qp6t9%2FcsxPd%2F4%2BISNsZ8amCUFBp9EmWj5s6b61fxojvVAqQsViAFRoyKc8IJ%2BqQVaX25YUOiIYI%2FiRbkqTgeoixWonpMKB3YqciiCAoK8dbrg5nLHzS5EPtMyIgFv0oV4nYHhlLmJ7AhjErxYtWwOfSD9g16vX%2Fc442uSBZ%2Bk2OSWDUHw2GBct7fHtJBC%2FQ65UcfAZBmaK0wkgcGES3AJUWLDNkAtYdkTGS76hS6ZVmvGep7M%2BIUPEyuTyEaGT28tRdZqbPllah8wxVMWA%2BUi5rwMPvdDVvbNUyDOKTlIQEQWDveOwAYL6LFoGvLBcdjGWsYUUBXoN8Z3AkHJdYLjk%2FX0gvUhDoHjuhaLtwEdB6ASOs0L6TQaerhPH16ami2WWxujdSvj6wNA8VrV7e9m%2F7NIZvi3RjGG%2Behn1Deg7zCx9kPABHjsrIVPeTiWeC171V%2BjcjpaL%2Fr1mTdb%2B212WFbiju8b%2FEGuUut0pVo4LYWziUspt7zcE6hYHAEqdSq68MaK27rREhnVcygPez2YFFr6f9e7O%2FNbUJc1YQL%2FZcPEcmAiXky4fKpKH6P1HHBovaJLOOSHlRe2OVLTAdpKDCkJ1iko1G2p9tXXhMZophKvimSry7QqXle0Myj3dC%2F1efQ5LEhACnHlgnaJnq5dxE1dW%2B8ES7Ffn5RvyWXdTbGYK8OuZRJ8kPKYnZltHQaFzvHuz8TxO0%2BZYcf7Higuk41TRZZNh6i8yd%2BFRu2I0q0KhePkwiauv4nvw9VVekqw%2BAPZ9S%2FcVnl2tpl23z5oUlrpMFHPE1XuF%2BCBDy8mviDHXxz2CHzPO3K%2Fb3HehoD4Wx%2FjpnmjKyQNheFqni3rIA%2FPIMBRTPISogfu%2Bh6wzius2RwBugxL2JoRMNdiVgADaCsSxueWN%2Fedstim73oc0OvRmFUc3ZIYiKRvmk4ZGx7ddBKNIRjRMdtJnm6yUGxNYDoZ4v5bOkg9dw4HLHllri9gyLZAn9DQqQ7lwiw6QOl2%2FEJTLmQiaJgW%2Fp4fqMivSBmCWr0I1BjQYRDiwhd3Vtsrup3JCVWcZJDg9LKT9W5xkRj3MYResVIZlF8mE6cbYmJ3b6og1QS%2BZFvDATOUF1yukoS3Z2cUpDbGLHLfLu0RJsGJPOgbswVrkOQr2khOEftmdWjhod6maO%2BNuHpXuncZwa4xRHCG2o0qEcLkl8G06K1L0pb2Dzb1wBL92janaKvq9kAekQR6tWKw87B%2Fucy4e0of7VVdKci%2BiEbS3zT%2FXUge%2FsV%2Fhhv%2FEt1gWjv0ElKJonzblpuS4XtOXbS9ZW%2FAJ8rAJXdwWZrNiHOTWTBtLmzb5wY80eMOmoUc0hbuapI7HhtYr3Ie2hgho5qUWKaOkLPzMhq%2FlbCOsoYqkZy8cK4wMl1twdizCen6ao0w1aTiDWR7B0sBBQPEWVnQfEpq3Rlf%2F2X2OR7LMV0hnuo%2BBXGx%2BghF2TMwGR6kUMKeaQYJa5x%2FuuDUGTTA6Eoj2JY0wuYQuH0%2BFvJw%2FGC5%2F5nOr9rMovtq6nVGR6JJNzMk%2F%2FPCq7c%2BkRfPX0g1JvUqBnu8Yk8AKd4ukdJqHEnoGTBqQsjB9%2BHwWnmnCnTX%2FbJI3w3sVrnZjeDIjUFYjxWCxPFMewEwAO1Wy2vOxC4D7rH5gzPgkhOSnNx%2FrccsEjRXjYp%2FDw77VpNO2tW2u%2BghnjJ1ewFz9a0S9MqPwS%2FTp0rShIXVhgwr098uZe0qxYTWOd4e8A0FDkhCo36YQhVIgcGAoxhUR2D4IlpnUQPqMvGV0JxXiNp8D58PLi0vekGgjf9Bt0iUzW6&__VIEWSTATE2=yqh6M9gqK5iFpCgGJ9PC4%2FC8Cr2t6kwVktCHuDu%2BLtskdOVROOdeEZpJl%2BxhsWPzb2BY9y1EhjQZZ4fplozVlxl9lk%2FgMFHA%2BMauDDzh0gd7ho5iSX8qzz5W82q7t8XD6oZM38geMFS1qtb%2BtbVPqof5WxmdXxR%2Fj5Da8RH0%2BHNzvcTYtWTl7ZuL0zPhfi6e%2FCyJWgquKKCUkp2asTs9hCfGj0R8X7kpjLg%2BwU99CzDiN%2FPAUvfx4P4dyZs7fWKG4sq5pg13dHCYc8R9Ds1CsWfSU6PkgMEViiWFft8qfRLI16ecsryhvyHMc95f8zPZomh0RFTiTlJGQsZYo8ocgpM1QpGyZOEgN80uPUg6qQFBlWLx9Buf7KMhE0NBFDxIEVRbMeZCgnasVczFtXOHxGqEfpORKExoUmasaPVhQYbpz5uPikxjTTGcKP%2Fzz5071ajrAai7ECIxoh2OIocHui3lGfsVF13oA72LaktYP6r9b8Z9YSMCzxyrc3JPZG4CazKyHAAIIAk1hUm13hFRlgdnjw03%2BS1SyF5%2BRgV32mV2cV6E6dcKqfq8AA2VgEa6NldNvHLl2ZXTuey9ZmvsWv1rKs6XAUN6P711iLwLoCI0bBfQkt9rR3mdFX8Yshm6vM737KHS0hzb5RIUzDy15%2BFuL8IhMOO8cy0MkW%2F2mKEqkboqIJaqc%2BLBFPpa5XHYueIlLelCxAJYDjPaTJnDKD%2BSXa60Rt8%2BOk97kC39nbrbPByNJRxBvsL4lILDMrJ%2FM31GbCviLl2CJv2bUXVHBTM4n0IhJehgeOnXGX2EPuCE8lh0Tkie3PNgKJCtphJXag5lY4bTeKlCJdEG3W%2BH0Sy3ZSNR%2FHU4WSP7zpexeRZyjRSjcIXrj0WUMh%2FiEoxQ7zwMgGIOz%2F2%2Bw9COKIvQtK21zTGVDUIMmC5o3DDQud9WOV2v%2FB0AktmcMkA4goPEt1Cho4a%2F9Hk%2BnhVJbU7ndL7iN9orj4UJjU4dCkQUmzMQ5Cdj%2B7N0t4h1yZIbO3i9kd6Qn6P8pULqdQ5dwSwUWLvtsYm5dgbKQRUAfjOZEBtFhEFIGrWTWH9jLAI0yqdrIaG2u8YJZRjATc8YqiYF6yDbAVyay5oDVwloOS9N0mYRX58Y2%2B%2Fg8CJ9pdzwsZbVJnnSrCSJdylLK%2FD5eaO271CMhSL1nFIwW0LDU7CgmHXslu8v2Rp9ce1b5E71bDN5asrhs34b3PAjRDReDhoEhIO5epHiqTLl5E8yAR%2BGPXpaIwLI5iKiE9NCA3%2FskZtEspIf4cl%2Fn5GTwgEDDliRKLqjMlsPVB4jxI0R0lJr901qZigUkIwovwofz06Br5RIGWjnjNewCtD7KdbCxEKyLeFCJt8H4GA5vwejYGEg3pIoblRBtRGZsEquVBTrcRQGDYjh2HPhJgrnMW0VCZHJIYYivgjW%2BAzsryKGjtoVZMIk9%2F0ErWvFJb1EqXPFHVnApkGHfZy5Gs5OmZwC0XaEL83iG6BJr5lS91a4u5pt9TvfdQWYDMJND6f8jQmdZpGiOb3koJhou8LSnDdVWzmSUC8XxgGRryKpIG9TvBUXJ1LDIKaRqQKR69af%2BPGX2u4uYIHKIOeRk0mWrdVPoI3ni2p5FD9CFyITcWWejA83VGTrxO2JVK9RDuPD8fatWJf6ViWInGSw%2F6D2IulT35RhSOdKpzS2I6ZJmyA8PE1wvAU9j2v2ZyjA%2BDj%2FnqyVB3N5Hq1oTw%2F7KUhaTDBq0AMMinXGkg%2FQFQUXfSwEJL5a%2BuG4s%2BX7IMzibjIRKJE0fuTt4JTLYgek21Z%2BSGSU92dyXwJSMGpFon8yFjO6lfxiH013W%2FfuFVtAjEEjlnxhukkOLbF%2Bu%2BUOC89mOEW9BCAuSRWjXQom0K76%2Bh2J4iZPLrOpB%2BRy7O5oqUq2Ym5vyk%2BvIy7LMhqW2IjupsLioQ5nH%2FThPV%2FYKb62yQDgngNgc1%2BFGRDn%2FRIqRWa6ldwdW3FcvX976ehxSCad4e2ZNdDEaQOlidcynqVfN1RXJwbw4YgEaunGQg2XHAehYWFuScYD&__VIEWSTATE3=ICmrs7zidAkJtXKQrsWg1yl4v570qSdrf4bmSUnH%2B%2B8MwDSiQq4waSP3AvJ%2BTUTSV2WPw3HtRgMGDshTiz2lB%2FDqB%2BBomEMskUHi1i046iFVBJ4lVpMRMxWuqbttDDJxVkW5rzUCWpJSd2j7iRrXUPLEACeX0tla3PJD%2F2LKp7pA1Urh0W9EjMVBoxUxGpUxT9GNMrpvRNTWhEIaXTlEPG6pAKqOVcpN38TF177uHL5ldvQ1rwUZt0hphK8WjB%2FvVl2i%2BNsZn6TE%2BzE%2FZ32avrnsIGCIit1lNp37IN4vhZcsZlQ2HBL%2BeK%2BUDt0YDrDASiqG5qMtyc4rgQXfychnObn%2FSSvWJXNvJE2ptEqbdhhXbfFU4GmSD6CqQ8Qj65tI%2BsuEaqKdvoOqoQa%2F5NPCRkyEBY1c54YvQvdNVQGOpxHWYJO7cud%2BnhMwBnt6i3FXVoIEKD4EosrlelmEVkBa6NVIdq27o4RrdypxHV3Tg44w%2FAYoCtaqyALfr19pGDm7H7WIy%2BkIESvfoghyeRJgiIqF%2F%2FzHotp9UOjSZTR7X3rBMTE5ybX213TurJ89McSXtRBM6CR7bvYeLZCAFh0U%2BrhKrqbazHO8JdpTkeEHbupS61MlqlXC5EXB5%2FJJezJfBT4sHRCDJOxJzIOpkQtQ6NTKUIUUBoLIMy6YkvhviRoltitwPpZ6IS2HaYarmG0866C5UBZmQgz8UZMVwYNE3EMOJE8EOqULgRgnGYcREinbnoHGM1VUi3qU3vfZ%2FmyPXqA39gBywT09pmnRKClXO666946Y9IvbwMav46Y8tF9hZQvWDnVYyhanxpLg0VD3fOwJ%2FyYpb93sgA%2BOgY2GpNrAXhtuSZOX%2BrVD5EufOC0PWoAOWyz%2B2qq5XdHDJNqa%2F5GT1EWlOLkLYgWfsYy8MOAFewe3I5pXT8458XKLikxxW0Mskffq8p%2BhaaJVPS3JP%2FEwToSgvbtGP4cD2hBWV0ZYLWQ5Y5Io4d8UAPqQjiKdRu3W85q075MOaYGI7FVJyI7PoL257XgijYmhP8umRr98kCPcOv3brFFxnWgUXsCVZ2KcpsQGXqHZrSKcbTHNubhj0KSR%2BYENOIs53OAWbwouXEdqMR6tXbx9J7U2aR8p2C%2BUHq2BzmnuBIbKW106aK0Z2xnxdhsk%2Bw%2F%2FgHzmDX3rkV4XaJRU5fSWztDqGriC%2FmD8I2v6WJRjQHF27NexOhSXPUfPebY9oBj%2FCUy17JKn3vWDdiTs07fBJkt%2F%2BtwcbYQv9XSdE3KTHwvdHpSvZRG8xKUlUf%2FFKepzT76ssvHvap4xWo6P3LldT%2BYf3Xm8saMso46j9YYnz63FyhHrZhGccrypBXxG58yz81gxRF9N05hhRNNihbgUPKmZtJEt3EvHn8qNOK12ik0dux5YUxNQf5%2FlwdqNVA0RGoxCmzIY1KpM7f23CPFBBmOtRf1gfvPfM2HeHOICOYy4ThODUpaA9cuhESmFU6ESdA2IgUwU%2BjQB%2Bq8jClc0XzXujfVd0jU%2BuaL8oAARBDhoACAc0S7KIGLAWxsSjIgovgTf%2FVoBUQnEI6k4unabWbw6EQywqbTVRXs7qiL6f1LteLfrEWJs8ezBJI%2FJb2FQ8NB5YX702z%2F6j%2F%2F5V0G%2B2UlADOFajOIKsaKidNMIEPgv6e%2FI5ubUUhPiJTZiKKe396bpwvnmoOk48wex7jHRGHK3gwiAZ7%2Bl5Ddu1p07Ngms3zF8qHzlG%2BqDAyrx827A%2F1WI6JYgxLuu9fTLHANYCNKm1B4CC4ZgT99Bnivpq1mm9er6v0%2FDJ61uApZAQF7yCpDuicZfv%2F3VxquBRRJTNb2JhlTbG18%2Fb2noE0j2BvHBS79PFu5O8k1Rmbwvu31P89FUbCR2c4c%3D&__VIEWSTATEGENERATOR=65E7F3AF&__ASYNCPOST=true&';
        //self::testPostVars($post_vars, $actual);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4060&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded; charset=utf-8',
            'X-Requested-With: XMLHttpRequest',
            'X-MicrosoftAjax: Delta=true',
            'Sec-Fetch-Dest: empty',
            'Sec-Fetch-Mode: cors',
            'Sec-Fetch-Site: same-origin',
            'Priority: u=1'];


        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if((stripos($curl_result_post, 'pageRedirect') === false) ||  (stripos($curl_result_post, $event['item_id']) === false)) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $curl_result = self::getPage($basic_info['reg_fee'], 0, '', $headers);
            self::parseRegistrationAndFeesForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    if(stripos($ce_key, 'ClientState') === false) {
                        if ($this->form_signup_to_event[$ce_key] != $old_new) {
                            //mismatch of new value
                            return -2;
                        }
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }



    public function updateEmailsPage($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['email_section'], 0, '', $headers);
        self::parseEventForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $old_new) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }

            $this->form_signup_to_event[$ce_key] = $old_new;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change

        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }

        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //self::testPostVars($post_vars);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4060&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded',
            'X-Requested-With: XMLHttpRequest',
            'X-MicrosoftAjax: Delta=true',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1',
            'Priority: u=1'];

        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if((stripos($curl_result_post, 'pageRedirect') === false) ||  (stripos($curl_result_post, $event['item_id']) === false)) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $curl_result = self::getPage($basic_info['email_section'], 0, '', $headers);
            self::parseEventForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    if ($this->form_signup_to_event[$ce_key] != $old_new) {
                        //mismatch of new value
                        return -2;
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }


    public function updateDescriptionPage($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/png,image/svg+xml,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['formatted_description'], 0, '', $headers);
        self::parseEventForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $edits) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $string = urldecode($this->form_signup_to_event[$ce_key]);
            foreach($edits AS $edit) {
                $string = str_replace($edit['find'], $edit['replace'], $string);
            }
            $string_encoded1 = rawurlencode($string);
            $string_encoded2 = str_replace('%20', ' ', $string_encoded1);
            $search = ['%2F','%3C','%3D','%3A','%3B','%3E','%2C'];
            $replace = ['/','%3c','%3d','%3a','%3b','%3e','%2c'];
            $string_encoded3 = str_replace($search, $replace, $string_encoded2);
            $test = ($string_encoded3 == $this->form_signup_to_event[$ce_key]);
            $test1 = strcasecmp($string_encoded3, $this->form_signup_to_event[$ce_key]);
            $this->form_signup_to_event[$ce_key] = $string_encoded3;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change

        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }

        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //self::testPostVars($post_vars);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4060&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded',
            'X-Requested-With: XMLHttpRequest',
            'X-MicrosoftAjax: Delta=true',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1',
            'Priority: u=1'];

        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if((stripos($curl_result_post, 'pageRedirect') === false) ||  (stripos($curl_result_post, $event['item_id']) === false)) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $curl_result = self::getPage($basic_info['formatted_description'], 0, '', $headers);
            self::parseEventForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    $string = urldecode($this->form_signup_to_event[$ce_key]);
                    foreach($edits AS $edit) {
                        if (stripos($string, $edit['find']) !== false) {
                            //mismatch of new value
                            return -2;
                        }
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }

    public function updateEventContact($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/png,image/svg+xml,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID . '&item_id=' . $event['item_id'],
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['event_contact'], 0, '', $headers);
        self::parseEventForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $edit) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $this->form_signup_to_event[$ce_key] = $edit;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change

        }
        $this->form_signup_to_event['__ASYNCPOST'] = "true";
        $this->form_signup_to_event['RadAJAXControlID'] = "ctl00_ctl00_ajax_manager";
        $this->form_signup_to_event['script_manager'] = 'ctl00$ctl00$ctl00$ctl00$the_whole_schmearPanel|ctl00$ctl00$save_button';
        $this->form_signup_to_event['script_manager_TSM'] .= ';';
        unset($this->form_signup_to_event['DES_JSE']);
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }

        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        $actual = 'script_manager=ctl00%24ctl00%24ctl00%24ctl00%24criteria_type_select_and_displayPanel%7Cctl00%24ctl00%24update_button&style_sheet_manager_TSSM=%3BTelerik.Web.UI%2C%20Version%3D2018.2.710.45%2C%20Culture%3Dneutral%2C%20PublicKeyToken%3D121fae78165ba3d4%3Aen-CA%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A92753c09%3A91f742eb&script_manager_TSM=%3B%3BSystem.Web.Extensions%2C%20Version%3D4.0.0.0%2C%20Culture%3Dneutral%2C%20PublicKeyToken%3D31bf3856ad364e35%3Aen-CA%3Ae441b334-44bb-41f8-b8ef-43fec6e58811%3Aea597d4b%3Ab25378d2%3BTelerik.Web.UI%3Aen-CA%3A8b7d6a7a-6133-413b-b622-bbc1f3ee15e4%3A16e4e7cd%3A365331c3%3A24ee1bba%3Aed16cbdc%3A874f8ea2%3Ac128760b%3A19620875%3Ab2e06756%3A92fe8ea0%3Afa31b949%3A4877f69a%3A33715776%3Af46195d3%3A490a9d4e%3Abd8f85e4%3B&DES_Group=&changes_pending=&ctl00_ctl00_event_button_control_panel_event_window_manager_ClientState=&ctl00%24ctl00%24member_id=6698144&ctl00%24ctl00%24member_name=Suzanne%20L%20Richards&ctl00%24ctl00%24responsibility_text=&ctl00%24ctl00%24is_admin_checkbox=on&ctl00%24ctl00%24is_primary_checkbox=on&ctl00%24ctl00%24show_contact_email_radiobuttonlist=2&ctl00%24ctl00%24show_contact_phone_radiobuttonlist=0&ctl00%24ctl00%24show_contact_cell_phone_radiobuttonlist=2&ctl00%24ctl00%24notify_on_cancellation_checkbox=on&ctl00%24ctl00%24panel_completed_checkbox=on&__EVENTTARGET=ctl00%24ctl00%24update_button&__EVENTARGUMENT=&__VIEWSTATE=sIr8c5HYjQIGd4slrZkyrTtHgKv7EbqsUHUvSMNAsaC9TbtsmC%2BrqhbZt%2FesnSU7maUm5HFO40mIlHP5Y4BMnKeN3UzCboWfh%2FjYFD1jeHjtas7IADKUyiPuWPe7mZmJAr1pMpx0o24m2wL%2F9OHn1wO50lM22Tp5wBcui0gcsBwHm7Vua2xhI3UlmHB2%2Bsp%2FF3tawpwm5yJh9iVwrHlVcJfYElkoQUZ%2FkAA2%2FkYIy1g4noQQRbnC8vXdVuxXgkeh0MelOyetTMH59dPXMCAPHYidKFxcwDXjpllAJwp1OrwLWRYK9YD9SxgVkmfNqQ8DCXwKU0mQvjoZp06%2FQ13wOlf2toC7OtZ%2B6AruClE9T0iqMubIgMH70av4cAK5mDWs0ayjk%2FhuijzP88gd3RBLAbDAlRBX62%2BuCBihO8SBIhkHCIC9cTv5OfFqn6uuS2J5S%2FNopijRQfGghM7To9XmUUG9ZT0APB1TJprVFUcFayT1uEpbfcyeHCjfETgD6jKOK8SQHdI%2BPCDwhNltsVC%2FPTBRogb%2BRVAMc%2Fkb99srJP4ojf7pm%2Fr4AcgiZapMGuzoMFCj8gziK6rCEXhw0bknkPtD7UVH1hrHO0LbZrEn9mVaBUo%2BkDAVjl8BczFHZlTBW8rKJwRrwZJBjD2eBhZlGCqw1UbXRqgUXXUufTJQiocd53oSJp9pxonZafQCA%2FW7obLrroAmP1rw7Tkw4pBo6HMmVVMrS4GxL0GFV28DPgy1PKhcyoD0bwvzoJtSp8ckyOxnMktjhMq4krmaaIugNX14Y8eoy6BJUUg7fAg8tSoK%2B3dZpfSFKVa16t%2F77I%2F1YVvtFjIbYZA0AkNLDGw98ezg3vV%2F7iBRRbpXmWO9TA5%2FjQ%2B2bKBjCdNED%2BzzVh47ui3RZBuleR7mY6bhbwVeScu0tD1h8k76F4jvrCWFDwqVkrBlG4gtUDnj4gGUQqU%2BbxAu3NdNgJRRICtD491RTE80l2gRZEAHkGd74Qg7MC3wzCTWD1aPYosOd3TqMkteV1fv1OGdwatn1LDodCf0qYcYhCfGF3YBSs1d4GTR4D%2Bl%2FXTrN7XeUw9qQWmcbv21CXl3avTfnXMmhMezVKXtDgsSdmL3ywrNTxlNi%2BfXIyc68FSIx1GhmFsLqP4%2FuZWgVmKw%2FRrBgrsjI60UoFH1VsJoidnl5N3DGc3vYYE14dr2TQnfhFNz4s%2FIQM5t4bgP%2F5S6NzApykHkK%2B5V3x4RuWUVS25yhpn%2BsPHnz%2FLGXLBiQLEvlrIuD22ZbWlNPiwjA%2B7p7CRt4P25DNFlkohdUyq8K9LgDHISb5IZIqVfHRglv8dKg1U0maGf%2FNSvqVdUdgdJEpKIl%2FE14qeNxttZVmqc%2Bbfz8uGmLovagWQX6sOznm92r2mkSIW2UerlRuIRzYMoqvddDNAaSMdHYPfOwEqNUqnZ%2FOfNCu6JbmioyfqlvURtGvVTIDLW0ABWzTQyQJIKvswa3sNipzZDtm1js9%2FrgmHOOdFdLB8kbNB%2B9lbmgB08owFZeUh5jdXRlIci4s3JDy%2FgfGTiNCrarVsKOCo0tInAmOqdPGDPh5clDFCsNizhpu9qDLiAp6NIQep6%2FktjxeXp1guWRC2nm83624k8S2XhNH5JJKCJUHCi2NkRPoTnPtqcUS3TBwB7MnKkLIYxz9YpkooryqaO%2BcsQJDmfERwwGURxi3x2bdUaxvNNccJP9xp4kABbLA8dmZCM%2Fx0A0%2BROOsAkg8ojPUhM%2FD0mrzpxGr%2BsdQlm4Pl7l73c89b5RV6kj4RdDeD7BtjFz%2Bv7fm5FHUuiCCWWMVmIWK2y3rNbnR%2FdshB3OEAKYtw64oBK8CA1tA755Rh2xt%2Buk9A1CLYwUDsWJjFHCkqAZkvQpo5cSkFopNsCvawsEYq7%2B1dj9GMTJ7zCSC5Pw%2Fw9AQHrdYMNMv1SsLOhKWZN4adipuPKQI8vEOURbH48Qpge4vSruITQ4CrXbmfYKlHQktGSi5MyU%2FtxN4l8%2B8TwucpN2uk7cIdCwCTG86b3LHS8Ik8Xv3M1dkROw5031HEL&__VIEWSTATE1=pHiUn%2FDYUC8X1qJyCxESu1B%2BBUSkJblZgLJVT2QIpDi%2FXDMvw06A90hwHVpBU7aB4h2f4k33MHrECKOpaUM8%2BJ4PmJ98L3J8dTX8GjGYOGilou%2Fj7RZybRNPklKKK%2FnS3ADSJvbqaJVlmPcq0aWsLVkcH9zoJZdVdU6wZqTZ0AtrNufKBOhaHUnouLG3KEjAkBRLaDZEB0OVcle2CNU5k8quCWFdmAb86dqZWeA%2BoxpMllJyoBx6wblknKxXuyQgwhXKmYONe4cCwz9qVtD3P3MxcPScOfNJoCY1%2FveOdRhxwxn90pTJ3OfHLYRB8gXAREyWCwvnWwkDi8pgIwy7RnzwyWi79ziwttk%2FdyXxmoMUUOnUpI%2BCaAQTIJIdsQFtw%2Fxtt2VDxfAzvzICkboWAMohuhCCuO8feXSObfbVdupUU2RrO%2FtwbFI6KjwFrVb4JzPH28Bs%2FnNxdHgQK9vpl7TILbJtRk5oEadk832u9Kjwc1qDirIs9IxEMtbyFsKQ9a%2BnonTvztHRx2EHHYUDdhVGFfkKpk9KyYIdwJtwytu%2Fp5%2B5lZ%2Fi5LgqFicMMDqnq2GEH681Ak5XYPmeFj4iw3h3VYJYcmnNB2hJaAIhow8Ph7KJe3qesAdzfYti19Pguw7FvHaHgPyu1u20lzRxKUQQ5n0m4GjT5vSnLuzwPJWlN%2F1gBhux7vm3E25mdLlJVNCG73q7epgYvPR0t0%2BttAdOYjfABZlhmH9mFa%2FPmF%2FrcQWCb%2BfS7MM7UmJCLelsM3U23xNu2epa8MfWB31G8QPCNJMYH4ZCjbIMXOKzXcv57GLKg6%2FRmsYEvdzVv%2FQbF6GT256GGgZE5E1C5Yv9tLxpajSWaf8g06Vd5%2FLbOUu%2B1JgyBiIawsCaR4GlCGASexkmidzkKdFzuYWSOyvRQISEjpOQuywkXfwezy1OORW2DkN575dXd9WpkjCCCG39WG%2FxurnxONVOzrTAcdXXs8C4SiXzAICyZyvDJy5OFKuusb4mftu7dU6ah%2FA9e7miu74qEjdR2L2m8xvIA9nemwEq1TyF85RgrCRIlDLt4C0%2FzFB0dnL%2FJ1UrfhmzNPlEP7OVFYz1YRzqZoiQ8GTec6cqlOFNAJW2mEeSw1i9e3W4B8wCdtvkf4i7QcogIf7PhG3ai7Iz%2FY%2FyQf%2BV51%2B2dRKUIsGnAkgKfBfvXBZbHfIXXDNAEN00gBxnrKGm3K%2BxF%2F%2BkiwhDpisTI3HUz6Q45kGgYZ98U2moTrE7KZ7QEvrQzP2geNLVXMtVRsVynElmgPNoAIZfpkaKjRg4jOMmyhgJny9OtO%2Fpek%2Bp8igqUON56f66D3mSaGImtdA0OzQSwsfBDMnWgOpzn7zXLJ2LNrHzqWQxZgVXmZuFFaFv1PCFpB7EiwY8SB%2FznF2sRfb5M1MS1w2ULWmpPDZMtuQ43CkEijct5WB%2BZBQ5Me1saYM00Ho%2FNn0YZPp6b4dnWyIhehnkGn4a5zTVmfhXUMvLqc47qedqc6Qa09m54Vw%2FTNIS21Bkp7UaJAG%2FMhIpd68RX%2B0i%2Bsm%2Fzb5Z%2BvSeIl3qqHzgehUFlpbmv7UX8ZpC8sHkL1fzFjISHTH0Z4VffrMus%2FFlswDP7bTMJIFcd6wkWp4bpembgxcEZH%2F3rnjMWleo2bjtfBUwXAqaUdrzq4DTqg2IaK7%2BAHyzUJwFjnbNI0GbptVldfv%2BsioHIIwEU5AyX9LFzaBLVh6yTog9GN0uwVOq9SBSYAQ28IvZCmA1lnI1wirn8pDmRkiC0sjjDEvYfI7GxeynHBvjIDkIxc7Qg4OjGGDL2Bcbigdek8INKQ2%2BuYHFI%2F%2BhTs5aQF4IHJQA5VpX95cm9wy7bphKyYrBHzzXqJ7k2KPBx8fZXoc7Qo5XOpjMe2Q1lC787Vw1gxJbKMQaTbQKbS4YgUC8BHPR9e4A%2FGES86GGLAExQievjp65A5Q9GkgdOReHw5haCaIkXZhAOXcSwNRyuOYCU8Xhw%2FBmdH6i1MG4Z7msgsuCykKtURKGzy7TlbxRYEWuhnVoyDq8FrgWlByZH8%2Fp2MJ6&__VIEWSTATE2=ajyhsRR6dqpT1%2FRug77Efn9oW0KphK2NtxqugO0bghmhcUTxTQJxqkKCwekb2YdUfq6TJMIFIdxypuLdfCv7gQZ%2Fp9X4ChWolCm9nvoiSJLxbuxQspE3yJwHvI37GMn2Wnrv9x9Y2UFlg4qQeY52nYpm93TfBOzbwE5qXGO7wRm0SOUcOnu1Dq%2FvRR1UsHdj7GxyEwsu6goIxg1smAKOlILCD%2BD4ExvfeIDoiXfmH1yKFyQ3j6ijHCL36IaZeDFTOx24qqVpL7%2BdO0JbxFrwMV1nFp3VMGjfkhvavH5c%2FOBpXGu%2Fue1WWNjB7vmDQfdHKuxNiz%2FivusNj%2FCY3x0JLNoQXXEFk77fWtMtYJTli3oPUBIuQUYAgaMfZkv8v7KHVXGlYdRwDCK7G58TmvRQ9QI74z6fxyh6%2F%2BbdqStrsdI5cpbb7RxnqpS8QZGZ5FVxyS%2FMuKDNUP4rO5RdVTjghh2gq0j4xKdn9St2j4y0h%2FQlAwp93hzsUpGAzvFfwPzxjooK4bvju6IuNL4AcEn%2F2G9O6vq6m6hEfLZV%2BGtxJ1yrpKAvC%2Bx3VZcWBkyB0BS7hkEzJyFFh6CK5aG2uIpDRxw8EevumB0Lt2husUeUSDeJFmRGGA7kUDmnSpqhAYY7LOvtLQkcTXzJFCyycie0IEuh74ceKpwgwKJ2jcwZcGHww%2FiPnmrda1aYA69Rdcl%2FAux0Nck4Fiukqj9I6ayhCKEZJLH3CJFUGbLSykC74w4Z6gnN7fAiuh5jcrgZftRS5Pc490qTpxJFnnyiNfqPL1%2FYQSpy5DJoqFbKBGI%2FszeL2tpmgu6NEywxksDbMjWosPbyyCqukXRmVo5n%2BjyoSoNKJOFsnBimSHqmWELXNN7pCW8o1Krw7IHy%2BFRPTaIFXBEN%2FalKSzY2ZeUWRKcknsMIO8Gxo7JjQeqNM7Cg8EuQuz0BOdQOPhrreI2SGqCiiGM8tyAcaWIlRpSiXVTUtXIkyf1VXYLTj55Nkl6I6JM4DfeuiraYZLgl9kiowt3dE1JqARbzgBTv2ogVlXFK0DlvXcckX8KrOlZvfhTimBpFDHarcaA76zX4eoKh1CuXexcTnFv4hvLKe9kJGHUFWVp6BuiL9cabnSbOeSmj7bdlgVALg0DB8t%2FGqBaQ879t4Auu%2FF14nt4kq3Mv9%2FA08ms58pfD69nTKOaNpV9pplYTXbg%2FGIlXFJQWHUh7rZd8NE%2FRmngjT5vWUrTc%2BH8DbrxQSlyYKNLD4uUwVQPU%2F0yGcdR40qyIqkcoYL9%2Br2SInEamgsapWzgDI96v%2FzrEF5siNzoswXb0vSatAdovCfUAtEK5bXDoILRja4hcVIqS1OtbFsIRRIdhZe4zhc4QsAaKQs%2FvkJARrl9Fns%2B1Y0iUpEKe8B8%2BSJnO0UMpg7YEJ21N40jRMVu9kbFnjUStsaSR7PD6%2BY639t2GJC6vKbXMReFiUzJ0FEIXb%2Fo4N102%2BWQfXHkqdEOVJ7rSkr7i1jXIpMP6HlQSMOaXLiF20dY32QKgIZblKQqfvwWRv7RyCKnYYNui%2Fy03KWZ7gdzpc%2BrizLPRScuqnUzo7mSgV%2BU%2FWAqJTwezIX%2FXYrsD8K1VPK1VQumi00KVpMFPXgCiyXHNEEnaFOQSG9yCBkCJb5f3Ij15T5yA6YWHGzni7xdZNCLIGGV4FHl%2FNXshJEEQLLTOeNOBtiZAUCk0duG4kPEpYVRiAbDfUgQGzBGPtBCgbPLOyDQGRa08Xi3Hs66V9UzI8GFuEjd%2BeX68eqYC3rk9g2uLH8Hen9mDGS3C5ljho6542WwBuVECl3upfM1NrFl4tOwin2IlbgbpuY0FnkT0vOsXAX1iAD64x%2Bm4j9oW%2Fq6kKtY8RvGxFmsvBP3JHCRMWd1v1x%2B6khWb4XHsvgjOqF%2FbYyDjZcpW6hx315IZPY3wM2sN9Vhuuj7LTcgC3bRfiQ0uOj%2FYu2pa32eo6eY03MwzoPfh%2Ff0Yy8X%2BDbVmirVDYeQc4GCF0vVM6EdcofOSL7NnGotRyrDwj6J0Rix8CnjJafLvjS6t1pUVHq0W&__VIEWSTATE3=p3M6ejhUJ0RmWMYsdm1x3IDgWhNUXIsC1oo%2Bw7oDwm%2FwILlLDHdJluX%2Bi5VyKtk2eJ8A9qXSOjfPF7eb%2B4f87EifFKSbRha07ZWXYhPsquDT9x1TltGvyTfCE9nBSc4MakMxlctm1ZH0SQvzvYbXjp4w5iinG5NPElaTzD5F36w4mAUWMg5QNDVevqQcjCvKy%2BMSS3qce8S0qf%2BQBTz1aQ%2F%2ByonPRKyY%2FYU7cccNgIO4UCxzvU%2FrD2GpKjkivUQGXvWOZ4RyvD04X6DBxnHFDDiBpRpJjdqvfSRXWKODk69SiZECwbSXHsRte2Zp8%2BCOtWl6c6mnDcC867ed%2B8Q1ie3raoaZ6lHjVsZ8ZJWhWLwk5h5Di7Ci8fWv8SXDl9%2By4vOWx4Cy7b3KCXBWGCq35pTNQoSQ6Uxuoji2%2Fzh%2F8gx6KOSsL8wThOvluHz3Z8WEzVhrhKf7BEefFs0pNSOJDC9xgjEC3t8Aek20yJXvlaAQZJxyvVQ944LEu540Jy3JDbwQKy9XOcnETYo7hhBEcJTiBVxXieHFQ3LLiLhHtZMZnWsd4EvoG8%2BliJYJRpde4fb9mGFwdfiYdqbocmdJgxLCz%2Bj3mNz%2B8PMp2EX9XqHtCZkPhoXmYs%2FItCqO4sxhoJPycYa942k1RoYPouxeTDTiFPf05Ab3KoWmsSZkNyutn12tbycsWgT3BKKRm3k2M%2BXXXvmznmL6MeQgnvpm%2F%2FMma7FnjrmyJPWXGOCqehrPf5KR5fWFNpGGleEHQYZShreWVUo6t0TG6GcrzUjVOb92MKKmcXEgUeolNayuzY8BPIEIY8DCtTBHExcZYt0u1tLiE1%2BAc3AC5r%2F%2BjgCYRNt2iaRZJwdxFf9MYKkpIzvLcRtNXSHJPLbe88Nnn34y9IYasXyxAzu%2FZ0%2F%2Bckmtj0emxDold2E9ZlceJR1tcPJso%2BdlG6MhszoKXf3GdVq7MevwJLXaJRclqwULHACnM4Oy8Sm%2FYfj8eTHLAMp1wQWno9MG5IDRk42DAjG%2BQmGtC8WfF%2BCnJWEYzi6YiKXWfdVKTy8Ju0pu3R6zmdbulqzuaOoKVMWS5DOIM7AutW%2FQ35UgAb08L2yQrCU7nXxJsi%2Bekk1TauiWVbII9i38jQTr%2FjiWOnx6E31sPa30wOUeHQrbNALXHiT6WXsv5PFN7zBnDJ67y7b05mqDe9ilzhzsGVjriiB3HXn691oygpZbp9L%2BMDpi1LXu797NmKGxpIu9H%2FbN15Ka53MX8XpNQ4BDAcsqDvr57IrhiFheSE1gXUIPp5hKYDWh2zaQgr4IjWarGGyBGKow3T%2FRR%2FlQHdq6DronHgeLk8tUiBk%2Fu9ichWy12ozvjD0v0ebLoU98%2B1ZKA3DwB8ANHBsb4s7i8X2s5J5CGO7w4iYn4Bde%2ByCyZW0K8cXOzYq3%2FPLu4ze45mpQuG9nqPYOarcPf9zTJm6cQ9GNJ5N7Qubvl2YSx7%2Ba3864dH6tGkk5dpKnkyPp8aL1RrcB1IlRLrLXPUrsx%2B7MrEzGV1NuMvkJCRWYAEVMezHiLiqgVyOu8H3bUexfrtpt4BzIMoYO9OV%2BCMEB1sCFvSadGsE2%2FgC2YBfnsUMsdWLGMaoRD1jvslsq1ctbVwdGg9kTHuqr20lZaN0AhcGcCuo87i4zvISJJ5gD5WXgPcf7UPQbLJKIWMoLmZazA9r6elrXMQq5hdH5ToN4%2Fs9JYGtZAYgxoTFVJUTCbY1xIggMpnOiesOJ7ZM%2BnF0eKhTzDuXMDC7rD1Iq%2FlYDpST0z531%2BBu1DlYUt96FROncEmKSmUQ5Kw%2F0dC92t5ARuxw2XPIINo%2FwODSgs0eX48m3QGX7%2F254bO0skrbknsuJQppLOAoes5jcW2vResIlslHidXI1xPU%2Blyq%2Fv1sVa3yKzVxPBnuA2XQVOktEQRMHqqML9A%3D%3D&__VIEWSTATEGENERATOR=65E7F3AF&__VIEWSTATEFIELDCOUNT=4&__ASYNCPOST=true&RadAJAXControlID=ctl00_ctl00_ajax_manager';
        self::testPostVars($post_vars, $actual);

        $headers = ['Accept: */*',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4056&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded; charset=utf-8',
            'X-Requested-With: XMLHttpRequest',
            'X-MicrosoftAjax: Delta=true',
            'Sec-Fetch-Dest: empty',
            'Sec-Fetch-Mode: cors',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1',
            'Priority: u=1'];

        $this->url_signup_to_event = str_replace('&actr=3', '', $this->url_signup_to_event);
        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if((stripos($curl_result_post, 'pageRedirect') === false) ||  (stripos($curl_result_post, $event['item_id']) === false)) {
            //some kind of error occurred
            return -1;
        }

        return 0;   //no errors found
    }

    public function updateLocation($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID. '&item_id=' . $event['item_id'],
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['location_url'], 0, '', $headers);
        self::parseLocationForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $old_new) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $this->form_signup_to_event[$ce_key] = $old_new;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change
        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }

        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //self::testPostVars($post_vars);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4057&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_location_info', $post_vars, $headers);
        if(stripos($curl_result_post, 'An error occurred') !== false) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID. '&item_id=' . $event['item_id'],
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $curl_result = self::getPage($basic_info['location_url'], 0, '', $headers);
            self::parseLocationForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    if ($this->form_signup_to_event[$ce_key] != $old_new) {
                        //mismatch of new value
                        return -2;
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            if($key_old == 'ctl00$ctl00$zip_text') {
                                //for some reason this field goes from '   ' to '' so we can ignore it
                                continue;
                            }
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }


    public function updateEventCategory($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4004&club_id=' . CLUB_ID,
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result = self::getPage($basic_info['basic_info'], 0, '', $headers);
        self::parseBasicInformationForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $old_new) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $this->form_signup_to_event[$ce_key] = $old_new;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change
        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }
        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //self::testPostVars($post_vars);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4018&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1'];

        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if(stripos($curl_result_post, 'An error occurred') !== false) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4004&club_id=' . CLUB_ID,
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1'];

            $curl_result = self::getPage($basic_info['basic_info'], 0, '', $headers);
            self::parseBasicInformationForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    if ($this->form_signup_to_event[$ce_key] != $old_new) {
                        //mismatch of new value
                        return -2;
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }

    public function updatePolicies($event, $changes, $verify=false)
    {
        $basic_info = self::getBasicInformation($event, time());
        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
            'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID,
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1',
            'Priority: u=0, i'];
        $curl_result = self::getPage($basic_info['policy'], 0, '', $headers);
        self::parsePolicyForm($curl_result);
        $form_signup_to_event_old = $this->form_signup_to_event;
        $update_needed = false;
        $missing_keys = [];
        foreach($changes AS $ce_key => $old_new) {
            if(!isset($this->form_signup_to_event[$ce_key])) {
                $missing_keys[] = $ce_key;
            }
            $this->form_signup_to_event[$ce_key] = $old_new;
            unset($form_signup_to_event_old[$ce_key]);  //don't check that this field has changed because we expect it to change
        }
        if(count($missing_keys) >= count($changes)) {
            //none of the changes are going to happen so return an error
            return -5;
        }
        $post_vars = http_build_query($this->form_signup_to_event, '', '&', PHP_QUERY_RFC1738);
        //self::testPostVars($post_vars);

        $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
            ('Referer: https://' . URL_BASE . '/content.aspx?page_id=4015&club_id=' . CLUB_ID . '&item_id=' . $event['item_id']),
            'Content-Type: application/x-www-form-urlencoded',
            'Sec-Fetch-Dest: document',
            'Sec-Fetch-Mode: navigate',
            'Sec-Fetch-Site: same-origin',
            'Sec-Fetch-User: ?1',
            'Priority: u=0, i'];

        $curl_result_post = self::post($this->url_signup_to_event,0, 'post_update_basic_info', $post_vars, $headers);
        if(stripos($curl_result_post, 'An error occurred') !== false) {
            //some kind of error occurred
            return -1;
        }
        if($verify) {
            //now read back the member data to verify the update
            $headers = ['Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
                'Referer: https://' . URL_BASE . '/content.aspx?page_id=4055&club_id=' . CLUB_ID,
                'Sec-Fetch-Dest: document',
                'Sec-Fetch-Mode: navigate',
                'Sec-Fetch-Site: same-origin',
                'Sec-Fetch-User: ?1',
                'Priority: u=0, i'];
            $curl_result = self::getPage($basic_info['policy'], 0, '', $headers);
            self::parsePolicyForm($curl_result);
            if (count($this->form_signup_to_event)) {
                //see if the requested changes were made
                foreach($changes AS $ce_key => $old_new) {
                    if ($this->form_signup_to_event[$ce_key] != $old_new) {
                        //mismatch of new value
                        return -2;
                    }
                }
                //verify the rest of the values
                $diff = [];
                foreach($form_signup_to_event_old AS $key_old => $value_old) {
                    if((stripos($key_old, 'VIEWSTATE') !== false) ||  (stripos($key_old, 'script_manager_TSM') !== false)){
                        continue;
                    }
                    //if((stripos($key_old, 'ctl00') === 0) || (stripos($key_old, 'r_') === 0)) {
                    if(!isset($changes[$key_old])) {
                        if($value_old != $this->form_signup_to_event[$key_old]) {
                            $diff[$key_old] = [$value_old, $this->form_signup_to_event[$key_old]];
                        }
                    }
                    //}
                }
                if(count($diff)) {
                    return $diff;
                }
            }
            else {
                return -3;
            }
        }
        return 0;   //no errors found
    }

    public function parseRegistrationAndFeesForm($curl_result)
    {
        self::parseEventForm($curl_result);
        $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
        $this->form_signup_to_event['script_manager'] = 'ctl00$ctl00$ctl00$ctl00$the_whole_schmearPanel|ctl00$ctl00$save_button';
        $this->form_signup_to_event['DES_Group'] = "";
        $this->form_signup_to_event['ctl00$ctl00$payment_type_dropdown'] = "1";
        //$this->form_signup_to_event['ctl00$ctl00$waitlist_hours_text'] = "11";

    }

    public function parseBasicInformationForm($curl_result)
    {
        self::parseEventForm($curl_result);
        $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
        $this->form_signup_to_event['DES_Group'] = "";

    }

    public function parsePolicyForm($curl_result)
    {
        self::parseEventForm($curl_result);
        $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
        $this->form_signup_to_event['DES_Group'] = "";

    }

    public function parseLocationForm($curl_result)
    {
        self::parseEventForm($curl_result);
        unset($this->form_signup_to_event['DES_JSE']);
        //$this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
        //$this->form_signup_to_event['DES_Group'] = "";

    }

    public function parseEmailsForm($curl_result)
    {
        self::parseEventForm($curl_result);
        $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
        $this->form_signup_to_event['DES_Group'] = "";

    }

    public function parseEventForm($curl_result)
    {
        $offset = 0;
        $str_create = '$create(Telerik.Web.UI.';
        $str_get = '$get("';
        $curl_result_length = strlen($curl_result);
        self::parseForm($curl_result);
        self::parse_script_manager_TSM($curl_result);

        foreach($this->form_signup_to_event AS $key => $value) {
            //$this->form_signup_to_event[$key] = str_replace(' ', '+', $value);
            if($this->form_signup_to_event[$key] == 'True') {
                $this->form_signup_to_event[$key] = 'on';
            }
        }
        do {
            $start = stripos($curl_result, $str_create, $offset);
            if ($start !== false) {
                $comma = stripos($curl_result, ',', $start);
                if ($comma !== false) {
                    $function = substr($curl_result, ($start + strlen($str_create)), ($comma - $start - strlen($str_create)));
                }
                $left_bracket = stripos($curl_result, '{', $start);
                $right_bracket = stripos($curl_result, '}', $start);
                $json = substr($curl_result, $left_bracket, ($right_bracket - $left_bracket + 1));
                $json = str_replace('\u0027', "'", $json);
                $parameters = json_decode($json/*, true, 512,  JSON_HEX_APOS*/);
                $error =  json_last_error();
                $eerror1 = JSON_ERROR_CTRL_CHAR;
                $get = stripos($curl_result, $str_get, $start);
                if ($get !== false) {
                    $quote = stripos($curl_result, '"', ($get + strlen($str_get)));
                    if ($quote !== false) {
                        $get_name = substr($curl_result, ($get + strlen($str_get)), ($quote - $get - strlen($str_get) + 1));
                    }
                }
                $offset = $quote + 2;
                switch ($function) {
                    case 'RadCheckBox':
                        $needed_parms = ['text' => '','value' => '','enabled' => true,'autoPostBack' => false,'commandName' => '','commandArgument' => '','validationGroup' => null,'checked' => false];
                        $parm_values = [];
                        foreach($needed_parms AS $parm_name => $parm_default) {
                            if(isset($parameters->$parm_name)) {
                                $parm_values[$parm_name] = $parameters->$parm_name;
                            }
                            else {
                                $parm_values[$parm_name] = $parm_default;
                            }
                        }
                        $string = json_encode($parm_values, JSON_UNESCAPED_SLASHES );
                        $this->form_signup_to_event[$parameters->clientStateFieldID] = $string;
                        break;
                    case 'RadCheckBoxList':
                        $needed_parms = ['visible' => true,'enabled' => true,'selectedIndex' => 0,'toolTip' => '','validationGroup' => '','selectedIndices' => []];
                        $parm_values = [];
                        foreach($needed_parms AS $parm_name => $parm_default) {
                            if(isset($parameters->$parm_name)) {
                                $parm_values[$parm_name] = $parameters->$parm_name;
                            }
                            else {
                                $parm_values[$parm_name] = $parm_default;
                            }
                        }
                        $string = json_encode($parm_values, JSON_UNESCAPED_SLASHES );
                        $this->form_signup_to_event[$parameters->clientStateFieldID] = $string;
                        break;
                    case 'RadDateInput':
                        $needed_parms = ['enabled' => true,'emptyMessage' => '','validationText' => '','valueAsString' => '','minDateStr' => '1980-01-01-00-00-00','maxDateStr' => '2099-12-31-00-00-00','lastSetTextBoxValue' => ''];
                        //{"enabled":true,"emptyMessage":"","validationText":"2023-10-02-09-30-00","valueAsString":"2023-10-02-09-30-00","minDateStr":"1980-01-01-00-00-00","maxDateStr":"2099-12-31-00-00-00","lastSetTextBoxValue":"9:30+AM"}
                        $start = stripos($json, ',"dateFormat":');
                        if($start !== false) {
                            $json1 = substr($json, 0, $start) . '}';
                            $parameters = json_decode($json1);
                        }
                        $parameters->validationText = $parameters->_validationText;
                        $parameters->valueAsString = $parameters->_initialValueAsText;
                        $parameters->lastSetTextBoxValue = $parameters->_displayText;
                        $parm_values = [];
                        foreach($needed_parms AS $parm_name => $parm_default) {
                            if(isset($parameters->$parm_name)) {
                                $parm_values[$parm_name] = $parameters->$parm_name;
                            }
                            else {
                                $parm_values[$parm_name] = $parm_default;
                            }
                        }
                        $string = json_encode($parm_values, JSON_UNESCAPED_SLASHES );
                        $this->form_signup_to_event[$parameters->clientStateFieldID] = $string;
                        break;
                    default:
                        break;
                }
            }
        }while (($start !== false && ($offset < $curl_result_length)));
        $this->form_signup_to_event['style_sheet_manager_TSSM'] = ";Telerik.Web.UI, Version=2018.2.710.45, Culture=neutral, PublicKeyToken=121fae78165ba3d4:en-CA:8b7d6a7a-6133-413b-b622-bbc1f3ee15e4:92753c09:91f742eb:c86a4a06:1c2121e:e24b8e95:aac1aeb7:d7e35272:ba1b8630:ca0174c4;Telerik.Web.UI.Skins, Version=2018.2.710.45, Culture=neutral, PublicKeyToken=121fae78165ba3d4:en-CA:edc38b47-243a-4099-ad96-f39edfbd66b5:c18aa1b5:11be649e";
        $this->form_signup_to_event['__EVENTTARGET'] = 'ctl00$ctl00$save_button';
        //$this->form_signup_to_event['DES_JSE'] = "1";
        $this->form_signup_to_event['DES_Group'] = "";
        //remove the keys with _checkbox in it's name if the value is not 'on'
        foreach($this->form_signup_to_event AS $key => $value) {
            if(stripos($key, '_checkbox') !== false) {
                if($value == 'False') {
                    unset($this->form_signup_to_event[$key]);
                }
            }
        }
        $i=1;
    }

}
